package ru.loylabs.portal.config;

public interface URIConstants {

//--COMMON------------------------------------------------------------------------------------------------------------//

	String SLASH = "/";
	String VERSION_1_URI = "/v1";
	String MATCH_ALL_WILDCARD = "/**";

//--URI---------------------------------------------------------------------------------------------------------------//

	String AUTH_URI = "/auth";
	String LOGIN_URI = "/login";
	String TOKEN_URI = "/token";
	String REFRESH_TOKEN_URI = "/refreshToken";
	String BELL_NOTIFICATIONS_URI = "/bell_notifications";
	String MARK_URI = "/mark";
	String ALL_URI = "/all";
	String ACHIEVEMENTS_URI = "/achievements";
	String CALENDAR_URI = "/calendar";
	String CORPORATE_URI = "/corporate";
	String EVENTS_URI = "/events";
	String YANDEX_URI = "/yandex";
	String PERSON_URI = "/person";
	String CREDENTIALS_URI = "/credentials";
	String COMMUNITY_URI = "/community";
	String PERSONAL_URI = "/personal";
	String PUBLIC_URI = "/public";
	String MEMBERS_URI = "/members";
	String JOIN_URI = "/join";
	String LEAVE_URI = "/leave";
	String NEW_AVATAR_URI = "/new_avatar";
	String ROLES_URI = "/roles";
	String OWNER_URI = "/owner";
	String AVATAR_URI = "/avatar";
	String MESSAGES_URI = "/messages";
	String ATTACHMENTS_URI = "/attachments";
	String DEPARTMENTS_URI = "/departments";
	String DOWNLOAD_URI = "/download";
	String ZIP_URI = "/zip";
	String FEED_URI = "/feed";
	String COMMENTS_URI = "/comments";
	String TITLES_URI = "/titles";
	String STORIES_URI = "/stories";
	String STORY_GROUPS_URI = "/story_groups";
	String SETTINGS_URI = "/settings";
	String TAGS_URI = "/tags";
	String NOTIFICATIONS_URI = "/notifications";
	String EMAIL_URI = "/email";
	String BELL_URI = "/bell";
	String CURRENT_URI = "/current";
	String TYPES_URI = "/types";
	String REACTIONS_URI = "/reactions";
	String SMILES_URI = "/smiles";
	String PERSONS_URI = "/persons";
	String USERNAME_URI = "/username";
	String JOB_URI = "/job";
	String ROLE_URI = "/role";
	String PASSWORDS_URI = "/passwords";
	String RESET_URI = "/reset";
	String BLOCK_URI = "/block";
	String UNBLOCK_URI = "/unblock";
	String BACKGROUND_URI = "/background";
	String UPCOMING_BIRTHDATS_URI = "/upcomingBirthdays";
	String CITIES_URI = "/cities";
	String NOTE_URI = "/note";
	String KB_URI = "/kb";
	String SECTIONS_URI = "/sections";
	String SEARCH_URI = "/search";
	String ARTICLES_URI = "/articles";
	String MOVE_URI = "/move";
	String IDEAS_URI = "/ideas";
	String FAVORITE_URI = "/favorite";
	String UNMARK_URI = "/unmark";
	String ACCEPT_URI = "/accept";
	String REJECT_URI = "/reject";
	String CONFIRM_URI = "/confirm";
	String ARCHIVE_URI = "/archive";
	String REASSIGN_URI = "/reassign";
	String ARCHIVED_URI = "/archived";
	String TASKS_URI = "/tasks";
	String PERMISSIONS_URI = "/permissions";
	String PASSWORD_URI = "/password";
	String SELF_URI = "/self";
	String BUG_REPORT_URI = "/bug_report";
	String SEND_URI = "/send";
	String GRADE_URI = "/grade";
	String SKILL_URI = "/skill";
	String STATUS_URI = "/status";
	String REVIEW_URI = "/review";
	String REVIEW_RATING_URI = "/rating";
	String REVIEWER_URI = "/reviewer";
	String OWNER_REVIEW_URI = "/owner";
	String CALENDAR_LINK_URI = "/link";
	String INTEGRATED_CALENDAR_URI = "/integrated";

//--PATH-PARAMS-------------------------------------------------------------------------------------------------------//

	String ID_URI_PARAM = "/{id}";
	String ID_URI_PARAM_NAME = "id";
	String TAG_ID_URI_PARAM = "/{tagId}";
	String TAG_ID_URI_PARAM_NAME = "tagId";
	String STATUS_URI_PARAM = "/{status}";
	String STATUS_URI_PARAM_NAME = "status";
	String TASK_ID_URI_PARAM = "/{taskId}";
	String TASK_ID_URI_PARAM_NAME = "taskId";
	String ACHIEVEMENT_ID_URI_PARAM = "/{achievementId}";
	String ACHIEVEMENT_ID_URI_PARAM_NAME = "achievementId";
	String NOTIFICATION_ID_URI_PARAM = "/{notificationId}";
	String NOTIFICATION_ID_URI_PARAM_NAME = "notificationId";
	String COMMUNITY_ID_URI_PARAM = "/{communityId}";
	String COMMUNITY_ID_URI_PARAM_NAME = "communityId";
	String MESSAGE_ID_URI_PARAM = "/{messageId}";
	String MESSAGE_ID_URI_PARAM_NAME = "messageId";
	String FEED_ID_URI_PARAM = "/{feedId}";
	String FEED_ID_URI_PARAM_NAME = "feedId";
	String IDEA_ID_URI_PARAM = "/{ideaId}";
	String IDEA_ID_URI_PARAM_NAME = "ideaId";
	String COMMENT_ID_URI_PARAM = "/{commentId}";
	String COMMENT_ID_URI_PARAM_NAME = "commentId";
	String ATTACHMENT_ID_URI_PARAM = "/{attachmentId}";
	String ATTACHMENT_ID_URI_PARAM_NAME = "attachmentId";
	String KB_SECTION_ID_URI_PARAM = "/{sectionId}";
	String KB_SECTION_ID_URI_PARAM_NAME = "sectionId";
	String KB_ARTICLE_ID_URI_PARAM = "/{articleId}";
	String KB_ARTICLE_ID_URI_PARAM_NAME = "articleId";
	String TOKEN_URI_PARAM = "/{token}";
	String TOKEN_URI_PARAM_NAME = "token";
	String PERSON_ID_URI_PARAM = "/{personId}";
	String PERSON_ID_URI_PARAM_NAME = "personId";
	String NOTE_ID_URI_PARAM = "/{noteId}";
	String NOTE_ID_URI_PARAM_NAME = "noteId";
	String REACTION_ID_URI_PARAM = "/{reactionId}";
	String REACTION_ID_URI_PARAM_NAME = "reactionId";
	String SMILE_ID_URI_PARAM = "/{smileId}";
	String SMILE_ID_URI_PARAM_NAME = "smileId";
	String TYPE_URI_PARAM = "/{type}";
	String TYPE_URI_PARAM_NAME = "type";
	String TITLE_ID_URI_PARAM = "/{titleId}";
	String TITLE_ID_URI_PARAM_NAME = "titleId";
	String DEPARTMENT_ID_URI_PARAM = "/{departmentId}";
	String DEPARTMENT_ID_URI_PARAM_NAME = "departmentId";
	String STORY_GROUP_ID_URI_PARAM = "/{storyGroupId}";
	String STORY_GROUP_ID_URI_PARAM_NAME = "storyGroupId";
	String STORY_ID_URI_PARAM = "/{storyId}";
	String STORY_ID_URI_PARAM_NAME = "storyId";
	String FILE_NAME_URI_PARAM = "/{fileName}";
	String FILE_NAME_URI_PARAM_NAME = "fileName";
	String GRADE_ID_URI_PARAM = "/{gradeId}";
	String GRADE_ID_URI_PARAM_NAME = "gradeId";
	String SKILL_ID_URI_PARAM = "/{skillId}";
	String SKILL_ID_URI_PARAM_NAME = "skillId";
	String STATUS_ID_URI_PARAM = "/{statusId}";
	String STATUS_ID_URI_PARAM_NAME = "statusId";
	String STATUS_NAME_URI_PARAM = "/name/{statusName}";
	String STATUS_NAME_URI_PARAM_NAME = "statusName";
	String REVIEW_ID_URI_PARAM = "/{reviewId}";
	String REVIEW_ID_URI_PARAM_NAME = "reviewId";
	String CALENDAR_EVENT_URI_DATE_PARAM = "/{date}";
	String CALENDAR_EVENT_URI_DATE_NAME = "date";
	String CALENDAR_LINK_URI_PARAM = "/{linkId}";
	String CALENDAR_LINK_URI_NAME = "linkId";
}
