package ru.loylabs.portal.config.jwt;

import io.jsonwebtoken.Claims;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.exception.ApplicationException;
import ru.loylabs.portal.repository.PersonRepository;
import ru.loylabs.portal.service.security.Credential;

import static ru.loylabs.portal.exception.BaseException.Exception.USERNAME_NOT_FOUND;

@Component
@RequiredArgsConstructor
public final class JwtUtils {
	private final PersonRepository personRepository;

	public Credential generate(Claims claims) {
		return new Credential(personRepository.findByUsername(claims.getSubject())
				.orElseThrow(() -> new ApplicationException(USERNAME_NOT_FOUND)));
	}
}