package ru.loylabs.portal.config.resttemplate;

import java.io.IOException;
import org.springframework.http.HttpStatus;
import org.springframework.http.client.ClientHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.web.client.ResponseErrorHandler;
import ru.loylabs.portal.exception.ApplicationException;
import ru.loylabs.portal.exception.BaseException;

@Component
public class Yandex360ResponseErrorHandler implements ResponseErrorHandler {

	@Override
	public boolean hasError(ClientHttpResponse response) throws IOException {
		return response.getStatusCode().isError();
	}

	@Override
	public void handleError(ClientHttpResponse response) throws IOException {
		HttpStatus status = response.getStatusCode();
		if (status.equals(HttpStatus.NOT_FOUND))
			throw new ApplicationException(BaseException.Exception.YANDEX_360_USER_NOT_FOUND);
		else if (status.equals(HttpStatus.UNAUTHORIZED) || status.equals(HttpStatus.FORBIDDEN))
			throw new ApplicationException(BaseException.Exception.YANDEX_360_USER_UNAUTHORIZED);
		else
			throw new ApplicationException(BaseException.Exception.YANDEX_360_USER_SERVICE_INTERNAL_ERROR);
	}

}
