package ru.loylabs.portal.entity;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Type;
import ru.loylabs.portal.enums.AttachmentType;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Getter
@Setter
@Entity
public class Attachment {
	@Id
	@GeneratedValue
	private UUID id;

	@Enumerated(EnumType.STRING)
	@Type(type = "attachment_type_enum_type")
	@Column(name = "attachment_type")
	private AttachmentType attachmentType;

	private String name;

	private String extension;

	private long size;

	private String location;

	@ManyToMany(cascade = {CascadeType.MERGE, CascadeType.PERSIST},
			mappedBy = "attachments")
	private final Set<KbArticle> kbArticles = new HashSet<>();

}
