package ru.loylabs.portal.entity;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.time.Instant;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Getter
@Setter
@Entity
public class Community {
	@Id
	@GeneratedValue
	private UUID id;

	private String name;

	private String description;

	private Boolean privateCommunity;

	private Instant createdAt;

	@OneToMany(cascade = {CascadeType.REMOVE, CascadeType.MERGE, CascadeType.PERSIST}, mappedBy = "community")
	private final Set<Record> records = new HashSet<>();

	@OneToMany
	@JoinTable(name = "community_person_role",
			joinColumns = @JoinColumn(name = "community_id"),
			inverseJoinColumns = @JoinColumn(name = "person_id"))
	private final Set<Person> members = new HashSet<>();

	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "attachment_id")
	private Attachment avatar;
}
