package ru.loylabs.portal.entity;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Type;
import ru.loylabs.portal.enums.CommunityRole;

import javax.persistence.*;
import java.util.UUID;

@Getter
@Setter
@Entity
@Table(name = "community_person_role")
public class CommunityPersonRole {
	@Id
	@GeneratedValue
	private UUID id = UUID.randomUUID();

	@OneToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "community_id", referencedColumnName = "id")
	private Community community;

	@OneToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "person_id", referencedColumnName = "id")
	private Person person;

	@Enumerated(EnumType.STRING)
	@Type(type = "community_role_enum_type")
	private CommunityRole communityRole;
}
