package ru.loylabs.portal.entity;

import java.util.UUID;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import lombok.Getter;
import lombok.Setter;

@Entity
@Getter
@Setter
public class Department {

	@Id
	@GeneratedValue
	private UUID id;

	private String name;

	@Column(name = "yandex_department_id", nullable = true, unique = true)
	private Integer yandexDepartmentId;

	@ManyToOne
	@JoinColumn(name = "leader_id", referencedColumnName = "id")
	private Person leader;

	private Boolean isDefault = false;
}
