package ru.loylabs.portal.entity;

import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Entity
@Getter
@Setter
public class Emoji {
	@Id
	@GeneratedValue
	private UUID id;

	@Transient
	private int clickCount;

	@Transient
	private boolean pressed;

	@ManyToOne
	private Reaction reaction;

	@ManyToOne(fetch = FetchType.LAZY)
	private Smile smile;

	@ManyToMany(cascade = {CascadeType.MERGE}, fetch = FetchType.LAZY)
	@JoinTable(name = "emoji_person",
			joinColumns = @JoinColumn(name = "emoji_id"),
			inverseJoinColumns = @JoinColumn(name = "person_id"))
	@Fetch(FetchMode.SUBSELECT)
	private Set<Person> persons = new HashSet<>();
}