package ru.loylabs.portal.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.Type;
import ru.loylabs.portal.enums.IdeaStatus;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Getter
@Setter
@Entity
public class Idea extends Record {
	private String header;

	@Enumerated(EnumType.STRING)
	@Type(type = "idea_status_enum_type")
	private IdeaStatus status;

	private String response;
	@OneToOne
	@JoinColumn(name = "supervisor_id")
	private Person supervisor;

	@JsonIgnore
	@ManyToMany(cascade = {CascadeType.MERGE,CascadeType.PERSIST})
	@JoinTable(name = "favorites_idea",
			joinColumns = @JoinColumn(name = "idea_id"),
			inverseJoinColumns = @JoinColumn(name = "person_id"))
	Set<Person> liked = new HashSet<>();
}
