package ru.loylabs.portal.entity;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import java.util.UUID;

@Entity
@Getter
@Setter
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "links_calendar_users")
public class IntegratedCalendarLink {
	@Id
	@GeneratedValue
	private UUID id;

	@Column(name = "link_name")
	private String linkName;

	@ManyToOne
	@JoinColumn(name = "user_id", nullable = false)
	private Person person;

	@Column(name = "link_calendar")
	private String linkCalendar;
}