package ru.loylabs.portal.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import java.util.UUID;

@Entity
@Getter
@Setter
public class Job {
	@Id
	@GeneratedValue
	private UUID id;

	@OneToOne(cascade = {CascadeType.MERGE, CascadeType.REMOVE}, mappedBy = "job")
	@JsonIgnore
	Person person;

	@OneToOne
	@JoinColumn(name = "department")
	private Department department;

	@OneToOne
	@JoinColumn(name = "title")
	private Title title;

	@OneToOne
	@JoinColumn(name = "grade")
	private Grade grade;

}
