package ru.loylabs.portal.entity;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Entity
@Getter
@Setter
public class KbArticle {
	@Id
	@GeneratedValue
	private UUID id;

	private String name;

	private String content;

	@ManyToOne
	@JoinColumn(name = "section_id")
	private KbSection section;

	@ManyToMany(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinTable(name = "kb_article_attachment",
			joinColumns = @JoinColumn(name = "kb_article_id"),
			inverseJoinColumns = @JoinColumn(name = "attachment_id"))
	private final Set<Attachment> attachments = new HashSet<>();

}
