package ru.loylabs.portal.entity;

import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.proxy.HibernateProxy;

import javax.persistence.CascadeType;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.MapsId;
import javax.ws.rs.DefaultValue;
import java.util.Objects;

@Entity
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Inheritance(strategy = InheritanceType.JOINED)
public class Reviewers {
	@EmbeddedId
	@EqualsAndHashCode.Include
	public ReviewersId reviewersId;

	@MapsId("reviewerId")
	@ManyToOne(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinColumn(name = "reviewer_id", referencedColumnName = "id")
	private Person reviewer;

	@MapsId("reviewId")
	@ManyToOne
	@JoinColumn(name = "review_id")
	private ReviewPersonSkill review;

	@DefaultValue("false")
	@JoinColumn(name = "voted")
	private boolean voted;

	@Override
	public final boolean equals(Object o) {
		if (this == o) return true;
		if (o == null) return false;
		Class<?> oEffectiveClass = o instanceof HibernateProxy ? ((HibernateProxy) o).getHibernateLazyInitializer().getPersistentClass() : o.getClass();
		Class<?> thisEffectiveClass = this instanceof HibernateProxy ? ((HibernateProxy) this).getHibernateLazyInitializer().getPersistentClass() : this.getClass();
		if (thisEffectiveClass != oEffectiveClass) return false;
		Reviewers that = (Reviewers) o;
		return getReviewersId() != null && Objects.equals(getReviewersId(), that.getReviewersId());
	}

	@Override
	public final int hashCode() {
		return Objects.hash(reviewersId);
	}
}
