package ru.loylabs.portal.entity;

import java.util.UUID;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import lombok.Getter;
import org.hibernate.annotations.Type;
import ru.loylabs.portal.enums.CredentialPermission;
import ru.loylabs.portal.enums.CredentialPermissionGroup;


@Entity
@Getter
public class SecurityPermission {

	@Id
	@GeneratedValue
	private UUID id;

	private String name;

	private String description;

	@Enumerated(EnumType.STRING)
	@Type(type = "credential_permission_enum_type")
	private CredentialPermission permission;

	@Enumerated(EnumType.STRING)
	@Type(type = "credential_permission_group_enum_type")
	@Column(name = "permission_group")
	private CredentialPermissionGroup permissionGroup;

}



