package ru.loylabs.portal.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.Set;
import java.util.UUID;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class TaskTag {
	@Id
	@GeneratedValue
	private UUID id;

	private String name;

	private String color;

	@ManyToOne(cascade = {CascadeType.MERGE,CascadeType.PERSIST})
	@JoinColumn(name = "achievement_id", referencedColumnName = "id")
	private Achievement achievement;

	@JsonIgnore
	@ManyToMany(cascade = {CascadeType.MERGE, CascadeType.PERSIST})
	@JoinTable(name = "task_tag_task",
			joinColumns = @JoinColumn(name = "task_tag_id"),
			inverseJoinColumns = @JoinColumn(name = "task_id"))
	private Set<Task> tasks;
}
