package ru.loylabs.portal.entity.audit;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import java.time.Instant;
import java.util.UUID;

@MappedSuperclass
@Getter
@Setter
public abstract class AuditEntityBase {
	@Id
	@GeneratedValue
	private UUID id;

	private Instant createdAt;

	private Instant modifiedAt;

	private UUID createdBy;

	private UUID modifiedBy;

	public abstract Auditable<?> getEntity();

	public abstract void setEntity(Auditable<?> auditable);

}
