package ru.loylabs.portal.entity.settings;

import static javax.persistence.FetchType.LAZY;

import java.io.Serial;
import java.io.Serializable;
import java.util.UUID;
import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.ManyToOne;
import javax.persistence.MapsId;
import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import org.hibernate.annotations.Type;
import ru.loylabs.portal.enums.BellNotificationType;

@Getter
@Setter
@Entity
public class BellNotificationAllowedTags {

	@EmbeddedId
	private BellNotificationAllowedTagsId id;

	@MapsId("tagId")
	@ManyToOne(fetch = LAZY, optional = false)
	private SettingsTag tag;

	@Getter
	@Setter
	@NoArgsConstructor
	@AllArgsConstructor
	@EqualsAndHashCode
	@ToString
	@Embeddable
	public static class BellNotificationAllowedTagsId implements Serializable {

		@Serial
		private static final long serialVersionUID = 1L;

		@Enumerated(EnumType.STRING)
		@Type(type = "bell_notification_type_enum_type")
		@Column(name = "notification_type")
		private BellNotificationType notificationType;

		@Column(name = "tag_id")
		private UUID tagId;

	}

}
