package ru.loylabs.portal.enums;

import lombok.Getter;
import lombok.RequiredArgsConstructor;

import static ru.loylabs.portal.utility.StringUtils.isInvalid;

@Getter
@RequiredArgsConstructor
public enum SettingsTagType {

	//PERSONAL(author, who post/send)
	AUTHOR_NAME("AUTHOR_NAME"),
	AUTHOR_SURNAME("AUTHOR_SURNAME"),
	AUTHOR_DAY_OF_BIRTH("AUTHOR_DAY_OF_BIRTH"),
	AUTHOR_TITLE("AUTHOR_TITLE"),
	AUTHOR_EMAIL("AUTHOR_EMAIL"),

	//PERSONAL(target, who receive)
	TARGET_NAME("TARGET_NAME"),
	TARGET_SURNAME("TARGET_SURNAME"),
	TARGET_PATRONYMIC("TARGET_PATRONYMIC"),

	//ADDITIONAL INFO
	PASSWORD_CODE("PASSWORD_CODE"),
	PASSWORD_RAW("PASSWORD_RAW"),

	//RECORD INFO
	RECORD_CONTENT("RECORD_CONTENT"),

	//COMMUNITY INFO
	COMMUNITY_NAME("COMMUNITY_NAME"),

	//ACHIEVEMENT INFO
	ACHIEVEMENT_NAME("ACHIEVEMENT_NAME"),

	//TASK INFO(task name, task approval result etc.)
	TASK_NAME("TASK_NAME"),
	TASK_STATUS("TASK_STATUS"),
	TASK_APPROVAL_RESULT("TASK_APPROVAL_RESULT"),

	//IDEA INFO
	IDEA_HEADER("IDEA_HEADER"),

	//FEED INFO
	FEED_CONTENT("FEED_CONTENT"),

	//CALENDAR EVENT INFO
	CALENDAR_EVENT_NAME("CALENDAR_EVENT_NAME"),
	CALENDAR_EVENT_DATE("CALENDAR_EVENT_DATE"),

	//META INFO
	CURRENT_DATE("CURRENT_DATE"),
	PORTAL_LINK("PORTAL_LINK"),

	//BUG REPORT
	BUG_REPORT("BUG_REPORT"),

	//EMBEDDABLE IMAGES
	IMG_EMAIL_LOGO("IMG_EMAIL_LOGO"),
	IMG_EMAIL_LOGIN("IMG_EMAIL_LOGIN"),

	//PERSON SKILL
	AUTHOR_SKILL("AUTHOR_SKILL"),

	//REVIEW
	REVIEW_END_DATE("REVIEW_END_DATE");


	private final String code;

	public static SettingsTagType fromCode(String code) {
		if (isInvalid(code)) return null;
		for (SettingsTagType tag : SettingsTagType.values())
			if (code.equalsIgnoreCase(tag.getCode())) return tag;
		return null;
	}

}
