package ru.loylabs.portal.facade;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Task;
import ru.loylabs.portal.facade.interfaces.TaskFacade;
import ru.loylabs.portal.presentation.request.UpdateTaskSequenceStatusRequest;
import ru.loylabs.portal.service.interfaces.TaskRailService;
import ru.loylabs.portal.service.interfaces.TaskService;

import java.util.UUID;

@Component
@RequiredArgsConstructor
public class TaskFacadeImpl implements TaskFacade {

	private final TaskService taskService;
	private final TaskRailService railService;


	@Override
	public Task updateTaskStatusAndSequence(UpdateTaskSequenceStatusRequest request, UUID achievementId, UUID taskId, Person author) {
		var oldStatus = taskService.getTask(achievementId, taskId).getStatus();
		var task = request.getSequence() == null ?
				taskService.updateTaskStatus(achievementId, taskId, request.getStatus(),author)
				:
				taskService.updateTaskStatusAndSequence(request, achievementId, taskId,author);
		if (oldStatus != task.getStatus()) {
			railService.createRecordTaskStatusUpdate(author, task, oldStatus);
		}
		return task;
	}

}
