package ru.loylabs.portal.listener.achievement;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.AchievementEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class AchievementDeleteListener implements BaseEventListener<AchievementEvents.AchievementDeleteEvent> {

	private final BellNotificationRepository repository;

	@Override
	@Transactional
	@EventListener
	public void handle(AchievementEvents.AchievementDeleteEvent event) {
		repository.deleteAllBySubjectIdIn(event.getCommentIds());
		repository.deleteAllBySubjectIdIn(event.getTaskIds());
		repository.deleteAllBySubjectId(event.getAchievementId());
	}
}