package ru.loylabs.portal.listener.calendar;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.CalendarEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class CalendarDeleteRepeatEventListener implements BaseEventListener<CalendarEvents.CalendarRepeatableDeleteEvent> {

	private final BellNotificationRepository repository;

	@Override
	@EventListener
	@Transactional
	public void handle(CalendarEvents.CalendarRepeatableDeleteEvent event) {
		repository.deleteAllBySubjectIdIn(event.getEventsId());
	}
}
