package ru.loylabs.portal.listener.calendar;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.CalendarEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@RequiredArgsConstructor
@Slf4j
@Component
public class CalendarEventDeleteListener implements BaseEventListener<CalendarEvents.CalendarDeleteEvent> {

	private final BellNotificationRepository repository;
	@Override
	@EventListener
	public void handle(CalendarEvents.CalendarDeleteEvent event) {
		repository.deleteAllBySubjectId(event.getEventId());
	}
}
