package ru.loylabs.portal.listener.comment;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.CommentEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class CommentDeleteListener implements BaseEventListener<CommentEvents.CommentDeleteEvent> {

	private final BellNotificationRepository notificationRepository;

	@Override
	@Transactional
	@EventListener
	public void handle(CommentEvents.CommentDeleteEvent event) {
		notificationRepository.deleteAllBySubjectId(event.getCommentId());
	}
}
