package ru.loylabs.portal.listener.community;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.CommunityEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class CommunityRecordDeleteListener implements BaseEventListener<CommunityEvents.CommunityRecordDeleteEvent> {

	private final BellNotificationRepository notificationRepository;


	@Override
	@Transactional
	@EventListener
	public void handle(CommunityEvents.CommunityRecordDeleteEvent event) {
		notificationRepository.deleteAllBySubjectId(event.getCommentId());
	}
}
