package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.Set;
import java.util.UUID;

public class CalendarEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class CalendarCreateEvent extends CalendarEvents {

		UUID eventId;
		UUID authorId;

		public static CalendarCreateEvent of(UUID eventId, UUID personId) {
			return new CalendarCreateEvent(eventId,personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class CalendarDeleteEvent extends CalendarEvents {

		UUID eventId;

		public static CalendarDeleteEvent of(UUID eventId) {
			return new CalendarDeleteEvent(eventId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class CalendarRepeatableDeleteEvent extends CalendarEvents {

		Set<UUID> eventsId;

		public static CalendarRepeatableDeleteEvent of(Set<UUID> eventId) {
			return new CalendarRepeatableDeleteEvent(eventId);
		}
	}
}
