package ru.loylabs.portal.listener.events;


import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.UUID;

public class CommentEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class CommentDeleteEvent extends CommentEvents {

		UUID commentId;

		public static CommentDeleteEvent of(UUID commentId) {
			return new CommentDeleteEvent(commentId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class CommentCreateEvent extends CommentEvents {

		UUID commentId;

		public static CommentCreateEvent of(UUID commentId) {
			return new CommentCreateEvent(commentId);
		}
	}

}
