package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.entity.Feed;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.Set;
import java.util.UUID;
import java.util.stream.Collectors;

public class FeedEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class FeedCreateEvent extends FeedEvents {

		UUID feedId;

		public static FeedCreateEvent of(UUID feedId) {
			return new FeedCreateEvent(feedId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class FeedDeleteEvent extends FeedEvents {

		UUID feedId;
		Set<UUID> commentsId;

		public static FeedDeleteEvent of(Feed feed) {
			var commentIds = feed.getComments().stream().map(Record::getId).collect(Collectors.toSet());
			return new FeedDeleteEvent(feed.getId(),commentIds);
		}
	}
}
