package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.Set;
import java.util.UUID;
import java.util.stream.Collectors;

public class IdeaEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class IdeaCreateEvent extends IdeaEvents {

		UUID ideaId;

		public static IdeaCreateEvent of(UUID ideaId) {
			return new IdeaCreateEvent(ideaId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class IdeaDeleteEvent extends IdeaEvents {

		UUID ideaId;
		Set<UUID> commentsId;

		public static IdeaDeleteEvent of(Idea idea) {
			var commentIds = idea.getComments().stream().map(Record::getId).collect(Collectors.toSet());
			return new IdeaDeleteEvent(idea.getId(),commentIds);
		}
	}
}
