package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.UUID;

public class PersonEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonCreateEvent extends PersonEvents {

		UUID personId;

		public static PersonCreateEvent of(UUID personId) {
			return new PersonCreateEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonDobEvent extends PersonEvents {

		UUID personId;

		public static PersonDobEvent of(UUID personId) {
			return new PersonDobEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonUpcomingDobEvent extends PersonEvents {

		UUID personId;

		public static PersonUpcomingDobEvent of(UUID personId) {
			return new PersonUpcomingDobEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonChangedJobEvent extends PersonEvents {

		UUID personId;

		public static PersonChangedJobEvent of(UUID personId) {
			return new PersonChangedJobEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonDobUpdateEvent extends PersonEvents {

		UUID personId;

		public static PersonDobUpdateEvent of(UUID personId){
			return new PersonDobUpdateEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonBlockedEvent extends PersonEvents {

		UUID personId;

		public static PersonBlockedEvent of(UUID personId) {
			return new PersonBlockedEvent(personId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class PersonUnblockEvent extends PersonEvents {

		UUID personId;

		public static PersonUnblockEvent of(UUID personId) {
			return new PersonUnblockEvent(personId);
		}
	}
}
