package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.List;
import java.util.UUID;

public class ReviewEvents extends BaseEvent {
	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class ReviewCreateEvent extends ReviewEvents {

		UUID reviewId;
		UUID reviewerId;
		UUID ownerReviewId;

		public static ReviewCreateEvent of(UUID reviewId, UUID reviewerId, UUID ownerReviewId) {
			return new ReviewCreateEvent(reviewId, reviewerId, ownerReviewId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class RemainderPassingReviewEvent extends ReviewEvents {

		UUID reviewId;
		UUID reviewerId;
		UUID ownerReviewId;

		public static RemainderPassingReviewEvent of(UUID reviewId, UUID reviewerId, UUID ownerReviewId) {
			return new RemainderPassingReviewEvent(reviewId, reviewerId, ownerReviewId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class ReviewDeleteEvent extends ReviewEvents {

		UUID reviewId;
		List<UUID> reviewersId;
		UUID ownerReviewId;

		public static ReviewDeleteEvent of(UUID reviewId, List<UUID> reviewersId, UUID ownerReviewId) {
			return new ReviewDeleteEvent(reviewId, reviewersId, ownerReviewId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class ReviewSingleDeleteEvent extends ReviewEvents {

		UUID reviewId;
		UUID reviewerId;
		UUID ownerReviewId;

		public static ReviewSingleDeleteEvent of(UUID reviewId, UUID reviewerId, UUID ownerReviewId) {
			return new ReviewSingleDeleteEvent(reviewId, reviewerId, ownerReviewId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class ReviewCreateEventOwner extends ReviewEvents {

		UUID ownerReviewId;
		UUID reviewId;

		public static ReviewCreateEventOwner of(UUID ownerReviewId, UUID reviewId) {
			return new ReviewCreateEventOwner(ownerReviewId, reviewId);
		}
	}
}
