package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.UUID;

public class StoryEvents extends BaseEvent {

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class StoryGroupCreateEvent extends StoryEvents {

		UUID storyGroupId;

		public static StoryGroupCreateEvent of(UUID storyGroupId) {
			return new StoryGroupCreateEvent(storyGroupId);
		}
	}

	@EqualsAndHashCode(callSuper = false)
	@Value
	public static class StoryGroupDeleteEvent extends StoryEvents {

		UUID storyGroupId;

		public static StoryGroupDeleteEvent of(UUID storyGroupId) {
			return new StoryGroupDeleteEvent(storyGroupId);
		}
	}

}
