package ru.loylabs.portal.listener.events;

import lombok.EqualsAndHashCode;
import lombok.Value;
import ru.loylabs.portal.listener.BaseEvent;

import java.util.Set;
import java.util.UUID;

public class TaskEvents extends BaseEvent {

	@Value
	@EqualsAndHashCode(callSuper = false)
	public static class TaskCreateEvent extends TaskEvents {

		UUID achievementId;
		UUID taskId;

		public static TaskCreateEvent of(UUID achievementId, UUID taskId) {
			return new TaskCreateEvent(achievementId,taskId);
		}
	}

	@Value
	@EqualsAndHashCode(callSuper = false)
	public static class TaskUpdateObserversEvent extends TaskEvents {

		UUID achievementId;
		UUID taskId;
		UUID appointerId;
		Set<UUID> oldObserverIds;

		public static TaskUpdateObserversEvent of(UUID achievementId, UUID taskId,UUID appointer,Set<UUID> oldObserverIds) {
			return new TaskUpdateObserversEvent(achievementId,taskId,appointer,oldObserverIds);
		}
	}

	@Value
	@EqualsAndHashCode(callSuper = false)
	public static class TaskCommentEvent extends TaskEvents {

		UUID achievementId;
		UUID taskId;

		public static TaskCommentEvent of(UUID achievementId, UUID taskId) {
			return new TaskCommentEvent(achievementId,taskId);
		}
	}


	@Value
	@EqualsAndHashCode(callSuper = false)
	public static class TaskStatusUpdateEvent extends TaskEvents {

		UUID achievementId;
		UUID taskId;
		UUID updatedById;

		public static TaskStatusUpdateEvent of(UUID achievementId, UUID taskId,UUID updatedBy) {
			return new TaskStatusUpdateEvent(achievementId,taskId,updatedBy);
		}
	}

	@Value
	@EqualsAndHashCode(callSuper = false)
	public static class TaskDeleteEvent extends TaskEvents {

		UUID achievementId;
		UUID taskId;
		Set<UUID> commentsIds;

		public static TaskDeleteEvent of(UUID achievementId, UUID taskId,Set<UUID> commentsIds) {
			return new TaskDeleteEvent(achievementId,taskId,commentsIds);
		}
	}
}
