package ru.loylabs.portal.listener.feed;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.FeedEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class FeedDeleteListener implements BaseEventListener<FeedEvents.FeedDeleteEvent> {

	private final BellNotificationRepository notificationRepository;


	@Override
	@EventListener
	@Transactional
	public void handle(FeedEvents.FeedDeleteEvent event) {
		notificationRepository.deleteAllBySubjectId(event.getFeedId());
		event.getCommentsId()
				.forEach(notificationRepository::deleteAllBySubjectId);
	}
}
