package ru.loylabs.portal.listener.idea;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.IdeaEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@Component
@RequiredArgsConstructor
public class IdeaDeleteListener implements BaseEventListener<IdeaEvents.IdeaDeleteEvent> {

	private final BellNotificationRepository notificationRepository;


	@Override
	@Transactional
	@EventListener
	public void handle(IdeaEvents.IdeaDeleteEvent event) {
		notificationRepository.deleteAllBySubjectId(event.getIdeaId());
		event.getCommentsId()
				.forEach(notificationRepository::deleteAllBySubjectId);
	}
}
