package ru.loylabs.portal.listener.job;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.GradeEvents;
import ru.loylabs.portal.repository.JobRepository;
import ru.loylabs.portal.service.interfaces.JobAdapter;

@Slf4j
@RequiredArgsConstructor
@Component
public class ReplaceGradeInJobOnDefaultValueListener implements BaseEventListener<GradeEvents.GradeDeletedEvent> {

	private final JobRepository jobRepository;
	private final JobAdapter jobAdapter;

	@Override
	@Async("listenersThreadPoolTaskExecutor")
	@EventListener
	public void handle(GradeEvents.GradeDeletedEvent event) {
		jobRepository.findAllByGradeId(event.getGradeId())
				.forEach(jobAdapter::setDefaultGrade);
	}
}
