package ru.loylabs.portal.listener.person;

import lombok.RequiredArgsConstructor;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.PersonEvents;
import ru.loylabs.portal.repository.PersonRepository;
import ru.loylabs.portal.service.interfaces.Yandex360UserService;

@Component
@RequiredArgsConstructor
public class PersonChangedJobListener implements BaseEventListener<PersonEvents.PersonChangedJobEvent> {

	private final PersonRepository personRepository;
	private final Yandex360UserService yandex360UserService;

	@Override
	@EventListener
	public void handle(PersonEvents.PersonChangedJobEvent event) {
		personRepository.findById(event.getPersonId())
				.ifPresent(yandex360UserService::updateYandexUser);
	}
}
