package ru.loylabs.portal.listener.person;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.enums.StoryGroupType;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.PersonEvents;
import ru.loylabs.portal.repository.StoryRepository;
import ru.loylabs.portal.service.story.updater.SystemBirthdaysStoryUpdater;

import javax.transaction.Transactional;

@Slf4j
@Component
@RequiredArgsConstructor
public class PersonDobUpdateListener implements BaseEventListener<PersonEvents.PersonDobUpdateEvent> {

    private final SystemBirthdaysStoryUpdater storyUpdater;

    @Override
    @EventListener
    public void handle(PersonEvents.PersonDobUpdateEvent event) {
        storyUpdater.refreshSystemGroup();
    }
}
