package ru.loylabs.portal.listener.person;

import lombok.RequiredArgsConstructor;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.PersonEvents;
import ru.loylabs.portal.service.interfaces.PersonService;

@Component
@RequiredArgsConstructor
public class PersonUnblockedListener implements BaseEventListener<PersonEvents.PersonUnblockEvent> {

    private final PersonService personService;

    @Override
    @EventListener
    public void handle(PersonEvents.PersonUnblockEvent event) {
        personService.unblockPerson(event.getPersonId());
    }
}
