package ru.loylabs.portal.listener.review;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.ReviewEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

import static ru.loylabs.portal.enums.BellNotificationType.CREATE_REVIEW;

@Slf4j
@Component
@RequiredArgsConstructor
public class ReviewSingleDeleteListener implements BaseEventListener<ReviewEvents.ReviewSingleDeleteEvent> {
	private final BellNotificationRepository repository;

	@Override
	@Transactional
	@EventListener
	public void handle(ReviewEvents.ReviewSingleDeleteEvent reviewEvents) {
		repository.deleteNotificationByTypeAndSubjectAndLink(CREATE_REVIEW, reviewEvents.getReviewerId(), reviewEvents.getReviewId());
	}
}
