package ru.loylabs.portal.listener.story;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.StoryEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@RequiredArgsConstructor
@Component
public class StoryGroupDeleteListener implements BaseEventListener<StoryEvents.StoryGroupDeleteEvent> {

	private final BellNotificationRepository repository;

	@Override
	@EventListener
	@Transactional
	public void handle(StoryEvents.StoryGroupDeleteEvent event) {
		repository.deleteAllBySubjectId(event.getStoryGroupId());
	}
}
