package ru.loylabs.portal.listener.task;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.listener.BaseEventListener;
import ru.loylabs.portal.listener.events.TaskEvents;
import ru.loylabs.portal.repository.BellNotificationRepository;

@Slf4j
@RequiredArgsConstructor
@Component
public class TaskDeleteListener implements BaseEventListener<TaskEvents.TaskDeleteEvent> {

	private final BellNotificationRepository repository;

	@Override
	@Transactional
	@EventListener
	public void handle(TaskEvents.TaskDeleteEvent event) {
		repository.deleteAllBySubjectIdIn(event.getCommentsIds());
		repository.deleteAllBySubjectId(event.getTaskId());
	}
}
