package ru.loylabs.portal.listener.telegram;

import lombok.RequiredArgsConstructor;
import org.springframework.context.event.ContextStartedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Component;
import org.telegram.telegrambots.meta.TelegramBotsApi;
import org.telegram.telegrambots.meta.exceptions.TelegramApiException;
import ru.loylabs.portal.service.telegram.LoyaltyBot;

@Component
@RequiredArgsConstructor
public class BotRegisterListener {

    private final LoyaltyBot loyaltyBot;
    private final TelegramBotsApi telegramBotsApi;

    @EventListener
    public void handle(ContextStartedEvent event) {
        try {
            telegramBotsApi.registerBot(loyaltyBot);
        } catch (TelegramApiException e) {
            throw new RuntimeException(e);
        }
    }
}
