package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateAchievementRequest;
import ru.loylabs.portal.presentation.request.UpdateAchievementRequest;
import ru.loylabs.portal.presentation.view.AchievementView;

import java.time.Instant;
import java.util.Set;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {TaskMapper.class,PersonMapper.class})
public interface AchievementMapper extends AbstractViewMapper<Achievement, AchievementView> {

//	@Mapping(target = "author.achievements", ignore = true)
//	@Mapping(target = "supervisor.achievements", ignore = true)
	AchievementView toView(Achievement achievement);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "tasks", ignore = true)
	@Mapping(source = "request.name", target = "name")
	Achievement toEntity(@MappingTarget Achievement achievement, UpdateAchievementRequest request);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "tasks", ignore = true)
	@Mapping(source = "request.name", target = "name")
	@Mapping(source = "date", target = "creationDate")
	@Mapping(target = "status", ignore = true)
	Achievement toEntity(CreateAchievementRequest request, Person author, Person owner, Set<Person> observers, Instant date);
}
