package ru.loylabs.portal.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Attachment;
import ru.loylabs.portal.enums.AttachmentType;
import ru.loylabs.portal.presentation.view.AttachmentView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface AttachmentMapper extends AbstractViewMapper<Attachment, AttachmentView> {

	Attachment toEntity(AttachmentType attachmentType, String name, String extension, long size, String location);
}
