package ru.loylabs.portal.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.BugReport;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.BugState;
import ru.loylabs.portal.presentation.view.BugReportRecordView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		uses = { PersonMapper.class, RecordMapper.class },
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface BugReportMapper {

	@Mapping(target = "author.role", source = "record.author.role")
	BugReportRecordView toView(Record record, long commentCount, BugState bugState);

	BugReport toEntity(Record record, BugState bugState);
}
