package ru.loylabs.portal.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.MappingTarget;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.IntegratedCalendarLink;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateIntegrateCalendarLink;
import ru.loylabs.portal.presentation.request.UpdateIntegrateCalendarLink;
import ru.loylabs.portal.presentation.view.IntegratedCalendarLinkView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface CalendarLinkMapper {

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "person", source = "person")
	IntegratedCalendarLink toEntity(CreateIntegrateCalendarLink createIntegrateCalendarLink, Person person);

	IntegratedCalendarLinkView toView(IntegratedCalendarLink integratedCalendarLink);

	IntegratedCalendarLink toEntity(@MappingTarget IntegratedCalendarLink integratedCalendarLink, UpdateIntegrateCalendarLink request);


}
