package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Community;
import ru.loylabs.portal.enums.CommunityRole;
import ru.loylabs.portal.presentation.request.CreateCommunityRequest;
import ru.loylabs.portal.presentation.request.UpdateCommunityRequest;
import ru.loylabs.portal.presentation.view.CommunityListView;
import ru.loylabs.portal.presentation.view.CommunityView;

import java.time.Instant;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		uses = {PersonMapper.class, AttachmentMapper.class},
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface CommunityMapper extends AbstractViewMapper<Community, CommunityView> {
	Community toEntity(CreateCommunityRequest request, Instant createdAt);

    Community toEntity(UpdateCommunityRequest request, @MappingTarget Community community);

	CommunityView toView(Community community, CommunityRole role);

	CommunityListView toCommunityListView(Community community, int membersCount);
}
