package ru.loylabs.portal.mapper;


import org.mapstruct.*;
import ru.loylabs.portal.entity.Department;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateDepartmentRequest;
import ru.loylabs.portal.presentation.request.UpdateDepartmentRequest;
import ru.loylabs.portal.presentation.view.DepartmentView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface DepartmentMapper extends AbstractViewMapper<Department, DepartmentView> {

	DepartmentView toView(Department department);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "yandexDepartmentId", ignore = true)
	@Mapping(target = "leader", source = "leader", defaultExpression = "java(null)")
	@Mapping(target = "name", source = "request.name")
	@Mapping(target = "isDefault", ignore = true)
	Department toEntity(CreateDepartmentRequest request, Person leader);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "yandexDepartmentId", ignore = true)
	@Mapping(target = "leader", source = "leader", defaultExpression = "java(null)")
	@Mapping(target = "name", source = "request.name")
	@Mapping(target = "isDefault", ignore = true)
	Department toEntity(@MappingTarget Department department, UpdateDepartmentRequest request, Person leader);
}
