package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Feed;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.presentation.view.FeedRecordView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		uses = {PersonMapper.class, AttachmentMapper.class},
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface FeedMapper {
	FeedRecordView toView(Record record, long commentCount);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "important", source = "important")
	Feed toEntity(Record record, boolean important);

	Feed toEntity(Record record, @MappingTarget Feed feed);
}
