package ru.loylabs.portal.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.MappingTarget;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Grade;
import ru.loylabs.portal.presentation.request.CreateGradeRequest;
import ru.loylabs.portal.presentation.request.UpdateGradeRequest;
import ru.loylabs.portal.presentation.view.GradeView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
        unmappedTargetPolicy = ReportingPolicy.IGNORE,
        nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface GradeMapper extends AbstractViewMapper<Grade, GradeView> {

    GradeView toView(Grade grade);

    @Mapping(target = "id", ignore = true)
    Grade toEntity(CreateGradeRequest request);

    Grade toEntity(@MappingTarget Grade grade, UpdateGradeRequest request);
}