package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.IdeaStatus;
import ru.loylabs.portal.presentation.request.UpdateIdeaRequest;
import ru.loylabs.portal.presentation.view.IdeaView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		uses = {PersonMapper.class, AttachmentMapper.class},
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface IdeaMapper {
	@Mapping(target = "id", ignore = true)
	Idea toEntity(Record record, String header, IdeaStatus status);

    Idea toEntity(UpdateIdeaRequest request, @MappingTarget Idea idea);

    IdeaView toView(Idea idea);

	IdeaView toView(Idea idea,boolean isFavorite);
}
