package ru.loylabs.portal.mapper;

import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.MappingTarget;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Department;
import ru.loylabs.portal.entity.Grade;
import ru.loylabs.portal.entity.Job;
import ru.loylabs.portal.entity.Title;
import ru.loylabs.portal.presentation.request.CreateJobRequest;
import ru.loylabs.portal.presentation.view.JobView;
import ru.loylabs.portal.service.yandex.dto.Yandex360UserResponse;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {GradeMapper.class})
public interface JobMapper extends AbstractViewMapper<Job, JobView> {

	JobView toView(Job job);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "title", source = "title")
	@Mapping(target = "department", source = "department")
	@Mapping(target = "grade", source = "grade", defaultExpression = "java(null)")
	Job toEntity(CreateJobRequest request, Title title, Department department, Grade grade);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "grade", source = "grade", defaultExpression = "java(null)")
	Job toEntity(@MappingTarget Job job, Grade grade, Title title, Department department);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "title", source = "title")
	@Mapping(target = "department", source = "department")
	Job toEntity(Yandex360UserResponse response, Title title, Department department);
}
