package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.KbArticle;
import ru.loylabs.portal.entity.KbSection;
import ru.loylabs.portal.presentation.request.CreateKbArticleRequest;
import ru.loylabs.portal.presentation.request.UpdateKbArticleRequest;
import ru.loylabs.portal.presentation.view.KbArticleListView;
import ru.loylabs.portal.presentation.view.KbArticleView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		uses = {AttachmentMapper.class},
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface KbArticleMapper extends AbstractViewMapper<KbArticle, KbArticleView> {
	@Mapping(target = "name", source = "request.name")
	@Mapping(target = "id", ignore = true)
	KbArticle toEntity(CreateKbArticleRequest request, KbSection section);

	@Mapping(target = "section", ignore = true)
	KbArticle toEntity(@MappingTarget KbArticle article, UpdateKbArticleRequest request);

	@Mapping(target = "name", ignore = true)
	@Mapping(target = "id", ignore = true)
	KbArticle toEntity(@MappingTarget KbArticle article, KbSection section);

	@Mapping(target = "sectionId", source = "article.section.id")
	KbArticleListView toArticleListView(KbArticle article);

	@Override
	@Mapping(target = "sectionId", source = "article.section.id")
	KbArticleView toView(KbArticle article);
}
