package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import org.mapstruct.util.Experimental;
import ru.loylabs.portal.entity.KbSection;
import ru.loylabs.portal.mapper.Qualifier.EmptyStringToNull;
import ru.loylabs.portal.presentation.request.CreateKbSectionRequest;
import ru.loylabs.portal.presentation.request.UpdateKbSectionRequest;
import ru.loylabs.portal.presentation.view.KbSectionSearchView;
import ru.loylabs.portal.presentation.view.KbSectionView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		uses = {AttachmentMapper.class, KbArticleMapper.class},
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface KbSectionMapper {
	KbSection toEntity(CreateKbSectionRequest request);

	@Mapping(target = "name", qualifiedBy = EmptyStringToNull.class)
	KbSection toEntity(@MappingTarget KbSection section, UpdateKbSectionRequest request);

	KbSectionView toView(KbSection kbSection, long articleCount);

	@Experimental
	KbSectionSearchView toSearchView(KbSection kbSection, long articleCount);

	@EmptyStringToNull
	default String emptyStringToNull(String s) {
		return s.isEmpty() ? null : s;
	}
}
