package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Note;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateNoteRequest;
import ru.loylabs.portal.presentation.request.UpdateNoteRequest;
import ru.loylabs.portal.presentation.view.NoteView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {PersonMapper.class})
public interface NoteMapper extends AbstractViewMapper<Note, NoteView> {
	@Mapping(target = "id", ignore = true)
	Note toEntity(CreateNoteRequest request, Person author, Person target);

	Note toEntity(@MappingTarget Note note, UpdateNoteRequest request);
}
