package ru.loylabs.portal.mapper;


import org.mapstruct.*;
import ru.loylabs.portal.entity.Grade;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.PersonSkill;
import ru.loylabs.portal.entity.Skill;
import ru.loylabs.portal.presentation.view.PersonSkillView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {SkillMapper.class, GradeMapper.class})
public interface PersonSkillMapper extends AbstractViewMapper<PersonSkill, PersonSkillView> {

	PersonSkillView toView(PersonSkill skill);

	@Mapping(target = "personSkillId.personId", source = "person.id")
	@Mapping(target = "personSkillId.skillId", source = "skill.id")
	PersonSkill toEntity(Person person, Skill skill, Grade grade);
}
