package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Reaction;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.RecordType;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;

import java.time.Instant;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		uses = {ReactionMapper.class},
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface RecordMapper {
	@Mapping(target = "id", ignore = true)
	@Mapping(target = "author", source = "author")
	@Mapping(target = "date", source = "date")
	@Mapping(target = "content", source = "request.content")
	@Mapping(target = "recordType", source = "recordType")
	@Mapping(target = "reaction", source = "reaction")
	@Mapping(target = "attachments", ignore = true)
	@Mapping(target = "community", ignore = true)
	@Mapping(target = "parentRecord", source = "parentRecord")
	@Mapping(target = "comments", ignore = true)
	Record toEntity(CreateRecordRequest request, Instant date, RecordType recordType, Reaction reaction, Record parentRecord, Person author);

	@Mapping(target = "content", source = "request.content")
	@Mapping(target = "comments",source = "record.comments")
	@Mapping(target = "attachments",source = "record.attachments")
	@Mapping(target = "modified",source = "modified")
	Record toEntity(UpdateRecordRequest request, Record record,boolean modified);
}