package ru.loylabs.portal.mapper;


import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.MappingTarget;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.Skill;
import ru.loylabs.portal.presentation.view.ReviewPersonSkillView;
import ru.loylabs.portal.presentation.view.ReviewersView;

import java.time.LocalDate;
import java.util.List;
import java.util.UUID;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {PersonMapper.class, SkillMapper.class, ReviewerSkillMapper.class, ReviewerSkillMapper.class})
public interface ReviewPersonSkillMapper extends AbstractViewMapper<ReviewPersonSkill, ReviewPersonSkillView> {

	@Mapping(target = "reviewers", source = "reviewers")
	ReviewPersonSkillView toView(ReviewPersonSkill reviewPersonSkill, List<ReviewersView> reviewers);

	@Mapping(target = "id", ignore = true)
	ReviewPersonSkill toEntity(Person owner, Skill skill, LocalDate startReview, LocalDate endReview);

	@Mapping(target = "id", ignore = true)
	ReviewPersonSkill toEntity(@MappingTarget ReviewPersonSkill reviewPersonSkill, Skill skill);

	UUID map(Person owner);
}