package ru.loylabs.portal.mapper;


import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.ReviewPersonSkillRating;
import ru.loylabs.portal.presentation.request.CreateReviewPersonSkillRating;
import ru.loylabs.portal.presentation.view.ReviewPersonSkillRatingView;

import java.util.UUID;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {PersonMapper.class, ReviewPersonSkillMapper.class, SkillMapper.class})
public interface ReviewPersonSkillRatingMapper extends AbstractViewMapper<ReviewPersonSkillRating, ReviewPersonSkillRatingView> {

	ReviewPersonSkillRatingView toView(ReviewPersonSkillRating reviewPersonSkill);

	@Mapping(target = "id", ignore = true)
	ReviewPersonSkillRating toEntity(ReviewPersonSkill review, Integer rating);
}
