package ru.loylabs.portal.mapper;


import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.Reviewers;
import ru.loylabs.portal.presentation.view.PersonReviewView;
import ru.loylabs.portal.presentation.view.ReviewersView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {PersonMapper.class, ReviewPersonSkillMapper.class, SkillMapper.class})
public interface ReviewerSkillMapper extends AbstractViewMapper<Reviewers, ReviewersView> {

	ReviewersView toView(Reviewers reviewers);

	@Mapping(target = "reviewersId.reviewerId", source = "reviewer.id")
	@Mapping(target = "reviewersId.reviewId", source = "review.id")
	Reviewers toEntity(Person reviewer, ReviewPersonSkill review);

	ReviewersView toReviewersView(PersonReviewView reviewer, boolean voted);
}
