package ru.loylabs.portal.mapper;

import java.util.Collection;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.MappingConstants;
import org.mapstruct.MappingTarget;
import org.mapstruct.NullValuePropertyMappingStrategy;
import ru.loylabs.portal.entity.SecurityPermission;
import ru.loylabs.portal.entity.SecurityRole;
import ru.loylabs.portal.presentation.request.CreateSecurityRoleRequest;
import ru.loylabs.portal.presentation.request.UpdateSecurityRoleRequest;
import ru.loylabs.portal.presentation.view.SecurityRoleView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = { SecurityPermissionMapper.class })
public interface SecurityRoleMapper {

	SecurityRoleView toView(SecurityRole role);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "role", source = "request.role")
	@Mapping(target = "name", source = "request.name")
	@Mapping(target = "description", source = "request.description")
	@Mapping(target = "isMutable", ignore = true)
	@Mapping(target = "permissions", source = "permissions")
	SecurityRole toEntity(CreateSecurityRoleRequest request, Collection<SecurityPermission> permissions);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "role", ignore = true)
	@Mapping(target = "name", source = "request.name")
	@Mapping(target = "description", source = "request.description")
	@Mapping(target = "isMutable", ignore = true)
	@Mapping(target = "permissions", source = "permissions")
	SecurityRole toEntity(@MappingTarget SecurityRole role, UpdateSecurityRoleRequest request,
						  Collection<SecurityPermission> permissions);

}
