package ru.loylabs.portal.mapper;


import org.mapstruct.*;
import ru.loylabs.portal.entity.Skill;
import ru.loylabs.portal.presentation.request.CreateSkillRequest;
import ru.loylabs.portal.presentation.request.UpdateSkillRequest;
import ru.loylabs.portal.presentation.view.SkillView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {GradeMapper.class})
public interface SkillMapper extends AbstractViewMapper<Skill, SkillView> {

	SkillView toView(Skill skill);

	@Mapping(target = "id", ignore = true)
	Skill toEntity(CreateSkillRequest request);

	@Mapping(target = "id", ignore = true)
	Skill toEntity(@MappingTarget Skill skill, UpdateSkillRequest request);
}
