package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Status;
import ru.loylabs.portal.presentation.request.CreateStatusRequest;
import ru.loylabs.portal.presentation.request.UpdateStatusRequest;
import ru.loylabs.portal.presentation.view.StatusView;

import java.util.UUID;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
unmappedTargetPolicy = ReportingPolicy.IGNORE,
nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface StatusMapper extends AbstractViewMapper<Status, StatusView>{

    @Mapping(target = "id", expression = "java(mapId(statusView.getId()))")
    Status toEntity(StatusView statusView);

    Status toEntity(CreateStatusRequest request);

    void updateEntity(UpdateStatusRequest request, @MappingTarget Status status);

    default UUID mapId(String id){
        return UUID.fromString(id);
    }
}
