package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.presentation.request.CreateStoryGroupRequest;
import ru.loylabs.portal.presentation.request.UpdateStoryGroupRequest;
import ru.loylabs.portal.presentation.view.StoryGroupView;

import java.time.Instant;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface StoryGroupMapper extends AbstractViewMapper<StoryGroup, StoryGroupView> {
	@Mapping(target = "author", source = "author")
	StoryGroup toEntity(CreateStoryGroupRequest request, Person author, Instant updateTime);

	StoryGroup toEntity(@MappingTarget StoryGroup storyGroup, UpdateStoryGroupRequest request);
}
