package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.entity.Story;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.presentation.request.UpdateStoryRequest;
import ru.loylabs.portal.presentation.view.StoryView;

import java.time.LocalDateTime;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface StoryMapper extends AbstractViewMapper<Story, StoryView> {
	Story toEntity(@MappingTarget Story story, UpdateStoryRequest request);

	@Mapping(target = "id", source = "record.id")
	@Mapping(target = "author", source = "record.author")
	@Mapping(target = "header", source = "header")
	Story toEntity(Record record, String header, LocalDateTime expireTime, StoryGroup group, Integer priority);
}