package ru.loylabs.portal.mapper;

import org.mapstruct.*;
import org.mapstruct.factory.Mappers;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.entity.TaskTag;
import ru.loylabs.portal.presentation.request.CreateTaskTagRequest;
import ru.loylabs.portal.presentation.request.UpdateTaskTagRequest;
import ru.loylabs.portal.presentation.view.TaskTagView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE,
		uses = {AchievementMapper.class})
public interface TaskTagMapper extends AbstractViewMapper<TaskTag, TaskTagView>{

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "tasks", ignore = true)
	@Mapping(source = "request.name",target = "name")
	@Mapping(source = "achievement", target = "achievement")
	TaskTag toEntity(CreateTaskTagRequest request, Achievement achievement);

	@Mapping(target = "id", ignore = true)
	TaskTag toEntity(UpdateTaskTagRequest request, @MappingTarget TaskTag tag);

	TaskTagMapper INSTANCE = Mappers.getMapper(TaskTagMapper.class);
}
