package ru.loylabs.portal.mapper;


import org.mapstruct.*;
import ru.loylabs.portal.entity.Title;
import ru.loylabs.portal.presentation.request.CreateTitleRequest;
import ru.loylabs.portal.presentation.request.UpdateTitleRequest;
import ru.loylabs.portal.presentation.view.TitleView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface TitleMapper extends AbstractViewMapper<Title, TitleView> {

	TitleView toView(Title title);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "isDefault", ignore = true)
	Title toEntity(CreateTitleRequest request);

	@Mapping(target = "id", ignore = true)
	@Mapping(target = "isDefault", ignore = true)
	Title toEntity(@MappingTarget Title title, UpdateTitleRequest request);
}
