package ru.loylabs.portal.mapper.settings;

import java.time.Instant;
import org.mapstruct.Mapper;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.settings.BellNotificationSettings;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.mapper.AbstractViewMapper;
import ru.loylabs.portal.presentation.request.settings.CreateBellNotificationSettingsRequest;
import ru.loylabs.portal.presentation.view.settings.BellNotificationSettingsView;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface BellNotificationSettingsMapper extends AbstractViewMapper<BellNotificationSettings, BellNotificationSettingsView> {

	BellNotificationSettings toEntity(CreateBellNotificationSettingsRequest request,
									  Instant creationDate,
									  BellNotificationType notificationType);

}