package ru.loylabs.portal.mapper.settings;

import org.mapstruct.Mapper;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.settings.EmailNotificationSettings;
import ru.loylabs.portal.enums.EmailNotificationType;
import ru.loylabs.portal.mapper.AbstractViewMapper;
import ru.loylabs.portal.presentation.request.settings.CreateEmailNotificationSettingsRequest;
import ru.loylabs.portal.presentation.view.settings.EmailNotificationSettingsView;

import java.time.Instant;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface EmailNotificationSettingsMapper extends AbstractViewMapper<EmailNotificationSettings, EmailNotificationSettingsView> {

	EmailNotificationSettings toEntity(CreateEmailNotificationSettingsRequest request, Instant creationDate, EmailNotificationType emailNotificationType);
}