package ru.loylabs.portal.mapper.settings;

import org.mapstruct.Mapper;
import org.mapstruct.MappingConstants;
import org.mapstruct.NullValuePropertyMappingStrategy;
import org.mapstruct.ReportingPolicy;
import ru.loylabs.portal.entity.settings.StorySettings;
import ru.loylabs.portal.enums.StoryGroupType;
import ru.loylabs.portal.mapper.AbstractViewMapper;
import ru.loylabs.portal.presentation.request.settings.CreateStorySettingsRequest;
import ru.loylabs.portal.presentation.view.settings.StorySettingsView;

import java.time.Instant;

@Mapper(componentModel = MappingConstants.ComponentModel.SPRING,
		unmappedTargetPolicy = ReportingPolicy.IGNORE,
		nullValuePropertyMappingStrategy = NullValuePropertyMappingStrategy.IGNORE)
public interface StorySettingsMapper extends AbstractViewMapper<StorySettings, StorySettingsView> {

	StorySettings toEntity(CreateStorySettingsRequest request, Instant creationDate, StoryGroupType groupType);
}