package ru.loylabs.portal.presentation.controller.ws;

import lombok.AllArgsConstructor;
import lombok.Data;
import org.springframework.messaging.handler.annotation.MessageMapping;
import org.springframework.messaging.handler.annotation.SendTo;
import org.springframework.stereotype.Controller;

@Controller
public class WebSocketPingPongController {

	@MessageMapping("/ping")
	@SendTo("/topic/ping")
	public WebSocketMessage pong(WebSocketMessage ping) {
		return new WebSocketMessage(String.format("pong(%s)", ping.getMessage()));
	}

	@Data
	@AllArgsConstructor
	private final static class WebSocketMessage {

		private String message;

	}

}
