package ru.loylabs.portal.presentation.request;

import java.time.LocalDate;
import java.util.UUID;
import javax.validation.Valid;
import javax.validation.constraints.Email;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Past;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import ru.loylabs.portal.presentation.request.validation.DomainEmail;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CreatePersonRequest {

	@NotNull
	@DomainEmail
	@Size(max = 150)
	private String username;
	private String password;
	@NotNull
	@Size(max = 70)
	private String name;
	@NotNull
	@Size(max = 70)
	private String surname;
	@Size(max = 70)
	private String patronymic;
	@NotNull
	@Past(message = "must be before the current date")
	private LocalDate dob;
	@NotNull
	private String gender;
	@NotNull
	@Valid
	private CreateJobRequest job;
	@NotNull
	private UUID cityId;
	@NotNull
	private String role;

}
