package ru.loylabs.portal.presentation.request;

import java.util.Set;
import java.util.UUID;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class CreateSecurityRoleRequest {

	@NotBlank
	@Size(max = 70)
	private String role;

	@NotBlank
	@Size(max = 70)
	private String name;

	@Size(max = 250)
	private String description;

	@NotEmpty
	private Set<UUID> permissions;

}
