package ru.loylabs.portal.presentation.request;

import lombok.Data;
import ru.loylabs.portal.enums.TaskStatus;
import ru.loylabs.portal.presentation.request.validation.NotBlankIfPresent;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.HashSet;
import java.util.Set;
import java.util.UUID;

@Data
public class CreateTaskRequest {

	@NotBlank
	@Size(max = 500)
	private String header;

	@NotBlankIfPresent
	@Size(max = 10000)
	private String content;

	private TaskStatus status = TaskStatus.PENDING;

	private Set<UUID> observerIds;

	private Set<UUID> tagIds = new HashSet<>();

}
