package ru.loylabs.portal.presentation.request;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import ru.loylabs.portal.presentation.request.validation.NotBlankIfPresent;

import javax.validation.Valid;
import javax.validation.constraints.Past;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.UUID;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class UpdatePersonRequest {
    @NotBlankIfPresent
    @Size(max = 70)
    private String name;
    @NotBlankIfPresent
    @Size(max = 70)
    private String surname;
//    @NotBlankIfPresent
    @Size(max = 70)
    private String patronymic;
    @Past(message = "must be before the current date")
    private LocalDate dob;
    private String gender;
    private UUID cityId;
    @Size(max = 5000)
    private String description;
    @Valid
    private UpdateContactRequest contact;
}
