package ru.loylabs.portal.presentation.request;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import ru.loylabs.portal.presentation.request.validation.NotBlankIfPresent;

import javax.validation.constraints.Size;
import java.util.Set;
import java.util.UUID;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class UpdateTaskRequest {

	@NotBlankIfPresent
	@Size(max = 500)
	private String header;

	@NotBlankIfPresent
	@Size(max = 10000)
	private String content;

	private Set<UUID> observerIds;

}
