package ru.loylabs.portal.presentation.request.validation;

import java.util.regex.Pattern;
import javax.validation.ConstraintValidator;
import javax.validation.ConstraintValidatorContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.hibernate.validator.internal.constraintvalidators.AbstractEmailValidator;
import ru.loylabs.portal.utility.StringUtils;

public class DomainEmailStringValidator extends AbstractEmailValidator<DomainEmail>
										implements ConstraintValidator<DomainEmail, CharSequence> {

	private Pattern domainPattern;

	@Autowired
	@Value("${mail.domain}")
	public void setDomainPattern(String domain) {
		this.domainPattern = StringUtils.isValid(domain)
							 ? Pattern.compile("^.+@" + Pattern.quote(domain) + "$")
							 : Pattern.compile(".*");
	}

	@Override
	public boolean isValid(CharSequence value, ConstraintValidatorContext context) {
		return super.isValid(value, context) && domainPattern.matcher(value).matches();
	}


}
