package ru.loylabs.portal.presentation.search;

import lombok.NonNull;
import lombok.RequiredArgsConstructor;

import java.util.Collections;
import java.util.List;

@RequiredArgsConstructor
public final class SearchReversePolishNotation {
	private final List<SearchElement> executionOrder;

	public List<SearchElement> get() {
		return Collections.unmodifiableList(executionOrder);
	}

	public void add(SearchCriteria criteria) {
		add(criteria, null);
	}

	public void add(SearchCriteria criteria, SearchOperation combinationOperation) {
		executionOrder.add(criteria);
		executionOrder.add(combinationOperation == null ? SearchOperation.AND : combinationOperation);
	}

	public void addCustomOrder(List<SearchElement> order, @NonNull SearchOperation combinationOperation) {
		if (order != null && !order.isEmpty()) {
			executionOrder.addAll(order);
			executionOrder.add(combinationOperation);
		}
	}
}
