package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.enums.AchievementStatus;

import java.util.Set;
import java.util.UUID;

public interface AchievementRepository extends JpaRepository<Achievement, UUID> {
	Page<Achievement> findAll(Specification<Achievement> specification, Pageable pageable);

	Set<Achievement> findAllByStatusAndOwnerId(AchievementStatus status, UUID id);

	int deleteAchievementById(UUID id);

	long deleteByOwnerIdAndStatus(UUID id, AchievementStatus status);

	boolean existsByIdAndAuthorId(UUID id, UUID personId);

	boolean existsByIdAndOwnerId(UUID id, UUID personId);

}
