package ru.loylabs.portal.repository;

import java.util.Optional;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.settings.BellNotificationSettings;
import ru.loylabs.portal.enums.BellNotificationType;

public interface BellNotificationSettingsRepository extends JpaRepository<BellNotificationSettings, UUID> {

	Optional<BellNotificationSettings> findTopByNotificationTypeOrderByCreationDateDesc(BellNotificationType notificationType);

	Page<BellNotificationSettings> findAll(Specification<BellNotificationSettings> specification, Pageable pageable);

}