package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;
import ru.loylabs.portal.entity.CommunityPersonRole;
import ru.loylabs.portal.enums.CommunityRole;

import java.util.Optional;
import java.util.UUID;

@Repository
public interface CommunityPersonRoleRepository extends JpaRepository<CommunityPersonRole, UUID> {

	Page<CommunityPersonRole> findAll(Specification<CommunityPersonRole> specification, Pageable pageable);

	Optional<CommunityPersonRole> findByCommunityIdAndCommunityRole(UUID communityId, CommunityRole role);

	Optional<CommunityPersonRole> findByCommunityIdAndPersonId(UUID communityId, UUID personId);

	int deleteByCommunityIdAndPersonId(UUID communityId, UUID personId);

	boolean existsByCommunityIdAndPersonIdAndCommunityRole(UUID communityId, UUID personId, CommunityRole role);

	boolean existsCommunityPersonRoleByCommunityIdAndPersonId(UUID communityId, UUID personId);

	boolean existsByCommunityId(UUID communityId);
}