package ru.loylabs.portal.repository;

import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.Community;

public interface CommunityRepository extends JpaRepository<Community, UUID> {

	Page<Community> findAll(Specification<Community> specification, Pageable pageable);

	List<Community> findCommunitiesByPrivateCommunityIsFalse();

	Optional<Community> findByIdAndPrivateCommunityIsFalse(UUID id);

	int deleteCommunityById(UUID id);

	boolean existsByIdAndPrivateCommunity(UUID id, Boolean privateCommunity);

}
