package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.Department;

import java.util.Optional;
import java.util.UUID;

public interface DepartmentRepository extends JpaRepository<Department, UUID> {

	Optional<Department> findByName(String name);

	boolean existsByNameIgnoreCase(String name);

	Page<Department> findAll(Specification<Department> specification, Pageable pageable);

	Optional<Department> findByYandexDepartmentId(Integer yandexDepartmentId);

	@Query("SELECT d FROM Department d WHERE d.isDefault = true")
	Department getDefaultDepartment();
}
