package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.settings.EmailNotificationSettings;
import ru.loylabs.portal.enums.EmailNotificationType;

import java.util.Optional;
import java.util.UUID;

public interface EmailNotificationSettingsRepository extends JpaRepository<EmailNotificationSettings, UUID> {
	Optional<EmailNotificationSettings> findTopByNotificationTypeOrderByCreationDateDesc(EmailNotificationType emailNotificationType);

	Page<EmailNotificationSettings> findAll(Specification<EmailNotificationSettings> specification, Pageable pageable);
}