package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.Grade;

import java.util.Optional;
import java.util.UUID;

public interface GradeRepository extends JpaRepository<Grade, UUID> {
    Optional<Grade> findByName(String name);

    Page<Grade> findAll(Specification<Grade> specification, Pageable pageable);

    boolean existsByNameIgnoreCase(String name);

    @Query("SELECT g FROM Grade g WHERE g.isDefault = true")
    Grade getDefaultGrade();
}
