package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import ru.loylabs.portal.entity.Idea;

import java.util.UUID;

public interface IdeaRepository extends JpaRepository<Idea, UUID> {
	Page<Idea> findAll(Specification<Idea> specification, Pageable pageable);

	Page<Idea> findAllByLikedId(UUID likedId, Pageable pageable);

	boolean existsByHeaderIgnoreCase(String header);

	boolean existsByIdAndLikedId(UUID ideaId,UUID personId);

	@Modifying
	@Query(nativeQuery = true,value = "delete from favorites_idea f where f.idea_id = :ideaId and f.person_id = :personId")
	void deleteFromFavoritesIdea(@Param("ideaId") UUID ideaId, @Param("personId") UUID personId);


	int deleteIdeaById(UUID id);
}
