package ru.loylabs.portal.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.IntegratedCalendarLink;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

public interface IntegratedCalendarLinkRepository extends JpaRepository<IntegratedCalendarLink, UUID> {
	List<IntegratedCalendarLink> findAllByPersonId(UUID personId);

	Optional<IntegratedCalendarLink> findAllByIdAndAndPersonId(UUID id, UUID personId);

	boolean existsByLinkCalendarIgnoreCase(String linkCalendar);

	boolean existsByPersonIdAndLinkNameIgnoreCase(UUID personId, String linkName);

}
