package ru.loylabs.portal.repository;

import org.mapstruct.util.Experimental;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.KbSection;

import java.util.UUID;

public interface KbSectionRepository extends JpaRepository<KbSection, UUID> {
	Page<KbSection> findAll(Specification<KbSection> specification, Pageable pageable);

	boolean existsByName(String name);

	int deleteSectionById(UUID id);

	@Experimental
	@Query(value = "select distinct s from KbSection s join fetch s.articles a where a.section.id = s.id and a.id in :asd",
			countQuery = "select count(distinct s) from KbSection s join s.articles a where a.section.id = s.id and a.id in :asd")
	Page<KbSection> findKbSectionByArticleIdWithContent(Iterable<UUID> asd, Pageable pageable);
}
