package ru.loylabs.portal.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import ru.loylabs.portal.entity.Note;

import java.util.Optional;
import java.util.UUID;

@Repository
public interface NoteRepository extends JpaRepository<Note, UUID> {
	int deleteByAuthorIdAndTargetId(UUID authorId, UUID targetId);

	@Query("select n from Note n where n.target.id = ?1 and n.author.id = ?2")
	Optional<Note> findByTargetIdAndAuthorId(UUID targetId, UUID authorId);

	@Query("select (count(n) > 0) from Note n where n.target.id = ?1 and n.author.id = ?2")
	boolean existsByUserIdAndAuthorId(UUID userId, UUID authorId);
}
