package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.PersonalBellNotification;

import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.UUID;

public interface PersonalBellNotificationRepository extends JpaRepository<PersonalBellNotification, UUID> {

	Page<PersonalBellNotification> findAll(Specification<PersonalBellNotification> specification, Pageable pageable);

	List<PersonalBellNotification> findAllByPersonId(UUID personId);

	List<PersonalBellNotification> findByPersonIdAndBellNotificationIdIn(UUID personId, Collection<UUID> notificationId);

	Optional<PersonalBellNotification> findByBellNotificationIdAndPersonId(UUID notificationId, UUID personId);

	long countByPersonIdAndSeenIsFalse(UUID personId);

	int deleteAllByPersonIdInAndBellNotificationSubjectId(Collection<UUID> personIds, UUID subjectId);

	int deleteByBellNotificationIdAndPersonId(UUID notificationId,UUID personId);

	int deleteAllByPersonIdAndSeenIsTrue(UUID personId);
}
