package ru.loylabs.portal.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.ReviewPersonSkillRating;

import java.util.List;
import java.util.UUID;

@Repository
public interface ReviewPersonSkillRatingRepository extends JpaRepository<ReviewPersonSkillRating, UUID> {
	@Modifying
	@Transactional
	@Query("DELETE FROM ReviewPersonSkillRating r WHERE r.review.id = (?1)")
	void removeAllByReviewId(UUID reviewId);

	List<ReviewPersonSkillRating> findAllByReview(ReviewPersonSkill review);
}
