package ru.loylabs.portal.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.entity.Reviewers;
import ru.loylabs.portal.entity.ReviewersId;

import java.util.List;
import java.util.Optional;
import java.util.UUID;

@Repository
public interface ReviewersRepository extends JpaRepository<Reviewers, ReviewersId> {
	Optional<Reviewers> findByReviewerIdAndReviewId(UUID reviewerId, UUID review);
	@Modifying
	@Transactional
	@Query("DELETE FROM Reviewers r WHERE r.review.id = (?1)")
	void removeAllByReviewId(UUID reviewId);

	List<Reviewers> findAllByReviewIdAndVotedFalse(UUID reviewId);

	@Modifying
	@Transactional
	@Query("SELECT r FROM Reviewers r WHERE r.reviewer.blocked = true AND r.voted = false")
	List<Reviewers> findAllByReviewerBlockedTrueAndVotedFalse();

	@Modifying
	@Transactional
	@Query("DELETE FROM Reviewers r WHERE r IN :reviewers")
	int removeByReviewer(@Param("reviewers") List<Reviewers> reviewers);
}
