package ru.loylabs.portal.repository;

import java.util.Collection;
import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.SecurityPermission;
import ru.loylabs.portal.enums.CredentialPermission;

public interface SecurityPermissionRepository extends JpaRepository<SecurityPermission, UUID> {

	Page<SecurityPermission> findAll(Specification<SecurityPermission> specification, Pageable pageable);

	Optional<SecurityPermission> findByPermission(CredentialPermission permission);

	Optional<SecurityPermission> findByName(String name);

	List<SecurityPermission> findByIdIn(Collection<UUID> ids);

	@Query(value = "SELECT * FROM security_permission AS sp " +
				   "JOIN role_permission AS rp ON rp.permission_id = sp.id AND rp.role_id = ?",
		   nativeQuery = true)
	List<SecurityPermission> findByRoleId(UUID roleId);

}
