package ru.loylabs.portal.repository;

import org.springframework.data.domain.Example;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.Status;

import java.util.Optional;
import java.util.UUID;

public interface StatusRepository extends JpaRepository<Status, UUID> {

    @Query("select s from Status s where upper(s.name) = upper(?1)")
    Optional<Status> findByNameIgnoreCase(String name);

    Page<Status> findAll(Specification<Status> specification, Pageable pageable);

    @Query("select (count(s) > 0) from Status s where upper(s.name) = upper(?1)")
    boolean existsByNameIgnoreCase(String name);
}
