package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.enums.StoryGroupType;

import java.util.Optional;
import java.util.UUID;

public interface StoryGroupRepository extends JpaRepository<StoryGroup, UUID> {
	Page<StoryGroup> findAll(Specification<StoryGroup> specification, Pageable pageable);

	@Query("select s from StoryGroup s where s.groupType = ?1")
	Optional<StoryGroup> findByGroupType(StoryGroupType groupType);

	int deleteStoryGroupById(UUID id);
}
