package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.entity.Story;
import ru.loylabs.portal.enums.StoryGroupType;

import java.util.Optional;
import java.util.UUID;

public interface StoryRepository extends JpaRepository<Story, UUID> {
	Page<Story> findAll(Specification<Story> specification, Pageable pageable);

	Optional<Story> findByIdAndGroupId(UUID id, UUID groupId);

	boolean existsByAuthorIdAndGroupGroupType(UUID authorId, StoryGroupType groupType);

	void deleteByAuthorIdAndGroupGroupType(UUID authorId, StoryGroupType groupType);
}
