package ru.loylabs.portal.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import ru.loylabs.portal.entity.settings.StorySettings;
import ru.loylabs.portal.enums.StoryGroupType;

import java.util.Optional;
import java.util.UUID;

public interface StorySettingsRepository extends JpaRepository<StorySettings, UUID> {
	Optional<StorySettings> findTopByGroupTypeOrderByCreationDateDesc(StoryGroupType groupType);

	Page<StorySettings> findAll(Specification<StorySettings> specification, Pageable pageable);
}
