package ru.loylabs.portal.repository;

import java.util.Optional;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import ru.loylabs.portal.entity.Title;

public interface TitleRepository extends JpaRepository<Title, UUID> {

	Optional<Title> findByName(String name);

	Optional<Title> findByNameIgnoreCase(String name);

	boolean existsByNameIgnoreCase(String name);

	Page<Title> findAll(Specification<Title> specification, Pageable pageable);

	@Query("SELECT t FROM Title t WHERE t.isDefault = true")
	Title getDefaultTitle();
}
