package ru.loylabs.portal.script;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.service.interfaces.ReviewSchedulingService;

@Slf4j
@Service
@EnableScheduling
@RequiredArgsConstructor
public class PersonReviewSchedulingExecutor {

	private final ReviewSchedulingService reviewSchedulingService;
	@Scheduled(cron = "0 55 8 * * *")
	public void removeBlockPersonInReview() {
		log.info("Delete a blocked person in review");
		var updated = reviewSchedulingService.deleteReviewerBecauseBlocking();
		log.info("Success. {} entities updated", updated);
	}
	@Scheduled(cron = "0 0 9 * * *")
	public void extendReview() {
		log.info("Extending the review");
		var updated = reviewSchedulingService.extendReview();
		log.info("Success. {} entities updated", updated);
	}

}
