package ru.loylabs.portal.script;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.service.interfaces.PersonYandexSyncSchedulingService;

@Slf4j
@Service
@RequiredArgsConstructor
@ConditionalOnProperty(value = "yandex.service.sync.enabled", havingValue = "true")
public class PersonYandexSyncSchedulingExecutor {

	private final PersonYandexSyncSchedulingService personYandexSyncSchedulingService;

	@Scheduled(cron = "${yandex.service.sync.cron:0 0 * * *}")
	public void sync() {
		log.info("Syncing Persons with Yandex360...");
		int updated = personYandexSyncSchedulingService.sync();
		log.info("Success. {} entities updated", updated);
	}

}
