package ru.loylabs.portal.script;

import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.messaging.simp.SimpMessagingTemplate;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.service.interfaces.OnlineStatusService;

@Slf4j
@Service
@EnableScheduling
@RequiredArgsConstructor
public class WebsocketSchedulingExecutor {
	private final SimpMessagingTemplate template;
	private final OnlineStatusService statusService;

	@ApiOperation(value = "Получение списка пользователей со статусом онлайн")
	@Scheduled(fixedRate = 5000)
	public void getOnlineStatus() {
//        log.info("Response of online status message via websocket");
		template.convertAndSend("/topic/status", statusService.getAll());
	}
}
