package ru.loylabs.portal.service;

import lombok.RequiredArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.entity.City;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;
import ru.loylabs.portal.repository.CityRepository;
import ru.loylabs.portal.service.filter.AbstractFilteringAndSortingService;
import ru.loylabs.portal.service.filter.ListFilter;
import ru.loylabs.portal.service.filter.ListFilterUtils;
import ru.loylabs.portal.service.interfaces.CityService;

@Component
@RequiredArgsConstructor
public class CityServiceImpl extends AbstractFilteringAndSortingService<City> implements CityService {

	private final CityRepository repository;
	private final ListFilterUtils filterUtils;

	@Override
	public Page<City> getAllCity(int page, int size, String sort, SearchReversePolishNotation criteria) {
		ListFilter listFilter = filterUtils.getListFilter(page, size, sort, criteria, City.class);
		return repository.findAll(getSpecification(listFilter), getPageable(listFilter));
	}
}
