package ru.loylabs.portal.service;

import lombok.RequiredArgsConstructor;
import org.springframework.messaging.simp.user.SimpUserRegistry;
import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.service.interfaces.PersonStatusService;
import ru.loylabs.portal.service.security.Credential;

import java.util.Set;
import java.util.stream.Collectors;

@Service
@RequiredArgsConstructor
public class PersonStatusServiceImpl implements PersonStatusService {
	private final SimpUserRegistry registry;

	@Override
	public Set<Person> getAllOnlinePersons() {
		return registry.getUsers().stream().
				map(u -> ((Credential) ((UsernamePasswordAuthenticationToken) u.getPrincipal()).getPrincipal()).getPerson())
				.collect(Collectors.toSet());
	}
}
