package ru.loylabs.portal.service;

import lombok.RequiredArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.entity.Smile;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;
import ru.loylabs.portal.repository.SmileRepository;
import ru.loylabs.portal.service.filter.AbstractFilteringAndSortingService;
import ru.loylabs.portal.service.filter.ListFilter;
import ru.loylabs.portal.service.interfaces.FilterUtils;
import ru.loylabs.portal.service.interfaces.SmileService;

@Service
@RequiredArgsConstructor
public class SmileServiceImpl extends AbstractFilteringAndSortingService<Smile> implements SmileService {

	private final SmileRepository smileRepository;
	private final FilterUtils filterUtils;

	@Override
	public Page<Smile> getAllSmiles(Integer page, Integer size, String sort, SearchReversePolishNotation criteria) {
		ListFilter listFilter = filterUtils.getListFilter(page, size, sort, criteria, Smile.class);
		return smileRepository.findAll(getSpecification(listFilter), getPageable(listFilter));
	}
}
