package ru.loylabs.portal.service.file;

import lombok.SneakyThrows;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Repository;
import ru.loylabs.portal.service.interfaces.FileStorage;

import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

@Repository
public class FileStorageImpl implements FileStorage {

	@Value("${file.path}")
	private String uploadPath;

	@Override
	@SneakyThrows
	public String save(byte[] content, String fileName) {
		Path newFile = Paths.get(getPath() + fileName);
		Files.createDirectories(newFile.getParent());
		Files.write(newFile, content);
		return newFile.toAbsolutePath().toString();
	}

	private String getPath() {
		return uploadPath.endsWith("/") ? uploadPath : uploadPath.concat("/");
	}

}


