package ru.loylabs.portal.service.filter;

import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;

public abstract class AbstractFilteringAndSortingService<T> {

	protected Pageable getPageable(ListFilter filter) {
		return PageRequest.of(filter.getPage(), filter.getSize(), Sort.Direction.valueOf(filter.getDirection()), filter.getSortBy());
	}

	protected Specification<T> getSpecification(ListFilter filter) {
		return SpecificationRequest.of(filter.getCriteria(), filter.getType());
	}
}

