package ru.loylabs.portal.service.filter;

import org.springframework.stereotype.Component;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;
import ru.loylabs.portal.service.interfaces.FilterUtils;

import java.util.Arrays;

@Component
public class ListFilterUtils implements FilterUtils {

	private static final String ASC = "ASC";

	private static final String DESC = "DESC";

	public ListFilter getListFilter(Integer page, Integer size, String sort, SearchReversePolishNotation criteria, Class<?> clazz) {
		return ListFilter.builder()
				.page(page)
				.size(size)
				.direction(getDirection(sort))
				.sortBy(getSortBy(sort))
				.criteria(criteria)
				.type(clazz)
				.build();
	}

	public String getDirection(String sort) {
		String[] sortValues = sort.split(",");
		return sortValues[sortValues.length - 1].equalsIgnoreCase(ASC) ? ASC : DESC;
	}

	public String[] getSortBy(String sort) {
		String[] sortValues = sort.split(",");
		return Arrays.copyOf(sortValues, sortValues.length - 1);
	}
}

