package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateAchievementRequest;
import ru.loylabs.portal.presentation.request.UpdateAchievementRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface AchievementService {

	Page<Achievement> getAllAchievements(int page, int size, String sort, SearchReversePolishNotation criteria);

	Page<Achievement> getAllPersonalAchievements(int page, int size, String sort, SearchReversePolishNotation criteria, UUID ownerId);

	Achievement getAchievement(UUID achievementId);

	Achievement createAchievement(CreateAchievementRequest request, Person author);

	Achievement updateAchievement(UUID achievementId, UpdateAchievementRequest request);

	Achievement confirmAchievement(UUID achievementId, Person confirming);

	Achievement archiveAchievements(UUID achievementId);

	Achievement setAchievementStatusNew(UUID achievementId);

	void deleteAchievement(UUID achievementId);

	void deleteArchivedAchievementForPerson(UUID personId);
}
