package ru.loylabs.portal.service.interfaces;

import static ru.loylabs.portal.utility.settings.DynamicSettingsUtils.formMessage;

import java.util.List;
import java.util.Map;
import lombok.RequiredArgsConstructor;
import ru.loylabs.portal.entity.settings.BellNotificationSettings;
import ru.loylabs.portal.entity.settings.SettingsTag;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.enums.SettingsTagType;

public interface BellNotificationManager {

	BellNotificationSettingsPack getNotificationSettingsPack(BellNotificationType notificationType);

	@RequiredArgsConstructor
	class BellNotificationSettingsPack {

		private final BellNotificationSettings settings;

		private final List<SettingsTag> tags;

		public String getMessageTitle() {
			return formMessage(settings.getHeader(), tags);
		}

		public String getMessage(Map<SettingsTagType, String> args) {
			return formMessage(settings.getContent(), tags, args);
		}

	}

}
