package ru.loylabs.portal.service.interfaces;

import java.util.Collection;
import java.util.UUID;
import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.BugReport;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.enums.BugState;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

public interface BugService {

	BugReport getBugReport(UUID id);

	Page<BugReport> getAllBugReportRecord(Integer page, Integer size, String sort, SearchReversePolishNotation criteria);

	BugReport saveBugReportRecord(CreateRecordRequest request, Person author, Collection<MultipartFile> files);

	void sendBugReport(CreateRecordRequest request, Person author, Collection<MultipartFile> files);

	BugReport addAttachments(UUID id, Collection<MultipartFile> files);

	BugReport changeStatus(UUID id, BugState bugState);

	BugReport deleteAttachments(UUID id, DeleteAttachmentsRequest request);

	void deleteBugReportRecord(UUID id);

	long countComments(UUID parentRecordId);

}
