package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.RecordType;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface CommentService {
	Page<Record> getAllComments(Integer page, Integer size, String sort, SearchReversePolishNotation criteria, UUID parentId, RecordType parentType);

	Record saveComment(CreateRecordRequest request, Person author, UUID parentId, RecordType parentType, Collection<MultipartFile> files);

	Record updateComment(UpdateRecordRequest request, UUID recordId, UUID parentId);

	Record addAttachments(UUID id, UUID parentId, RecordType type, Collection<MultipartFile> files);

	Record deleteAttachments(UUID id, UUID parentId, RecordType type, DeleteAttachmentsRequest request);

	void deleteComment(UUID recordId,UUID parentId);
}
