package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface CommunityRecordService {
	Record getCommunityRecord(UUID id, UUID communityId);

	Page<Record> getAllCommunityRecords(UUID communityId, Integer page, Integer size, String sort, SearchReversePolishNotation criteria);

	Record sendMessage(UUID id, CreateRecordRequest request, Person author, Collection<MultipartFile> files);

	Record updateMessage(UUID recordId, UUID communityId,  UpdateRecordRequest request);

	Record addAttachments(UUID id, UUID communityId, Collection<MultipartFile> files);

	Record deleteAttachments(UUID id, UUID communityId, DeleteAttachmentsRequest request);

	void deleteMessage(UUID id, UUID communityId);
}
