package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Community;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.AddMembersRequest;
import ru.loylabs.portal.presentation.request.CreateCommunityRequest;
import ru.loylabs.portal.presentation.request.UpdateCommunityRequest;
import ru.loylabs.portal.presentation.request.UpdateRoleInCommunityRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface CommunityService {
	Community getCommunity(UUID id);

	Page<Community> getAllCommunities(int page, int size, String sort, SearchReversePolishNotation criteria);

	Page<Community> getAllPublicCommunities(int page, int size, String sort, SearchReversePolishNotation criteria);

	void deleteMembers(UUID id, UUID[] personIds);

	Community saveAvatar(UUID id, MultipartFile file);

	Community saveCommunity(CreateCommunityRequest request, Person owner);

    Community saveCommunity(CreateCommunityRequest request, MultipartFile file, Person owner);

	Community updateCommunity(UUID id, UpdateCommunityRequest request);

    void deleteCommunity(UUID id);

	Community addMembers(UUID id, AddMembersRequest[] request,Person author);

	Community changeOwner(UUID communityId, UUID personId);

	Community updatePersonRoleInCommunity(UUID communityId, UpdateRoleInCommunityRequest request);

	Community joinCommunity(UUID communityId, UUID personId);

	void leaveCommunity(UUID communityId, UUID personId);
}
