package ru.loylabs.portal.service.interfaces;

import ru.loylabs.portal.entity.CorporateCalendarEvent;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.enums.CalendarEventType;
import ru.loylabs.portal.presentation.request.Recurrence;

import java.time.ZonedDateTime;
import java.util.List;
import java.util.UUID;

public interface CorporateCalendarEventService {

	List<CorporateCalendarEvent> getAllEvents();

	List<CorporateCalendarEvent> getAllRepeatingEvents(UUID repeatId);

	CorporateCalendarEvent getEvent(UUID eventId);

	CorporateCalendarEvent addEvent(String eventName,
									String description,
									CalendarEventType eventType,
									ZonedDateTime dateStart,
									ZonedDateTime dateEnd,
									Recurrence recurrence,
									Person author);

	List<CorporateCalendarEvent> getEventsAndBirthdaysForNextMonths(int months);

	void deleteEvent(UUID eventId, boolean repeatable);

}
