package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.Department;
import ru.loylabs.portal.presentation.request.CreateDepartmentRequest;
import ru.loylabs.portal.presentation.request.UpdateDepartmentRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface DepartmentService {

	Page<Department> getAllDepartment(int page, int size, String sort, SearchReversePolishNotation criteria);

	Department getDepartmentById(UUID id);

	Department createDepartment(CreateDepartmentRequest request);

	Department updateDepartment(UUID id, UpdateDepartmentRequest request);

	void deleteDepartment(UUID id);
}
