package ru.loylabs.portal.service.interfaces;

import java.util.Collection;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.utility.EmailEmbeddableFile;

public interface EmailAdapter {

	void sendSimpleMessage(String to, String subject, String text);

	default void sendMessage(String to, String subject, String text) {
		sendMimeMessage(to, subject, text, null, null);
	}

	default void sendMessageWithAttachments(String to, String subject, String text, Collection<MultipartFile> files) {
		sendMimeMessage(to, subject, text, files, null);
	}

	default void sendMessageWithEmbeddedFiles(String to, String subject, String text,
											  Collection<EmailEmbeddableFile> embeddableFiles) {
		sendMimeMessage(to, subject, text, null, embeddableFiles);
	}

	void sendMimeMessage(String to, String subject, String text, Collection<MultipartFile> files,
						 Collection<EmailEmbeddableFile> embeddableFiles);

}
