package ru.loylabs.portal.service.interfaces;

import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.BugReport;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.Task;
import ru.loylabs.portal.service.notification.email.EmailNotification;

import java.util.Collection;

public interface EmailNotificationFactory {

	EmailNotification createResetPasswordMessage(Person target, String passwordCode);

	EmailNotification createGeneratedPasswordMessage(Person target, String password);

	EmailNotification createGeneratedPasswordMessageWithLoginLink(Person target, String password, String loginLink);

	EmailNotification createTaskApprovalMessage(Task task, Person taskAuthor, Person taskReviewer, boolean isApproved);

	EmailNotification createBugReportMessage(BugReport report, Collection<MultipartFile> files);

	EmailNotification createNewIdeaMessage(Person target, Person ideaAuthor, Idea idea);

	EmailNotification createGeneratedPasswordForAdmin(Person target, Person createdPerson, String password);

	EmailNotification createBlockedUser(Person target, Person blockedUser);

	EmailNotification createBlockedAdmin(Person target, String passwordCode);
	EmailNotification createReview(Person reviewer, ReviewPersonSkill review);
}
