package ru.loylabs.portal.service.interfaces;

import static ru.loylabs.portal.utility.settings.DynamicSettingsUtils.formMessage;

import java.util.List;
import java.util.Map;
import lombok.RequiredArgsConstructor;
import ru.loylabs.portal.entity.settings.EmailNotificationSettings;
import ru.loylabs.portal.entity.settings.SettingsTag;
import ru.loylabs.portal.enums.EmailNotificationType;
import ru.loylabs.portal.enums.SettingsTagType;

public interface EmailNotificationManager {

	EmailNotificationSettingsPack getNotificationSettingsPack(EmailNotificationType emailNotificationType);

	@RequiredArgsConstructor
	class EmailNotificationSettingsPack {

		private final EmailNotificationSettings settings;

		private final List<SettingsTag> tags;

		public String getMessageTitle() {
			return formMessage(settings.getHeader(), tags);
		}

		public String getMessage(Map<SettingsTagType, String> args) {
			return formMessage(settings.getContent(), tags, args);
		}

	}

}
