package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Feed;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateFeedRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface FeedService {
	Feed getFeed(UUID id);

	Page<Feed> getAllFeedRecord(Integer page, Integer size, String sort, SearchReversePolishNotation criteria, boolean important);

	Feed saveFeedRecord(CreateFeedRequest request, Person author, Collection<MultipartFile> files);

	Feed updateFeed(UUID feedId, UpdateRecordRequest request);

	Feed addAttachments(UUID id, Collection<MultipartFile> files);

	Feed deleteAttachments(UUID id, DeleteAttachmentsRequest request);

	void deleteFeedRecord(UUID id);

	long countComments(UUID parentRecordId);
}
