package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.CreateIdeaRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.ProvideFeedbackRequest;
import ru.loylabs.portal.presentation.request.UpdateIdeaRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface IdeaService {
	Page<Idea> getAllIdeas(Integer page, Integer size, String sort, SearchReversePolishNotation criteria);

	Page<Idea> getFavoriteIdeas(int page, int size, String sort, SearchReversePolishNotation searchCriteria, Person person);

	Idea getIdea(UUID id);

    Idea updateIdea(UUID id, UpdateIdeaRequest request);

	Idea saveIdea(CreateIdeaRequest request, Person author, Collection<MultipartFile> files);

	void markAsFavorites(UUID id, Person person);

	void unmarkAsFavorites(UUID id,Person person);

	void acceptIdea(ProvideFeedbackRequest request, UUID id, Person supervisor);

	void rejectIdea(ProvideFeedbackRequest request, UUID id, Person supervisor);

	boolean isFavoriteForPerson(UUID ideaId, Person person);

	Idea addAttachments(UUID id, Collection<MultipartFile> files);

	Idea deleteAttachments(UUID id, DeleteAttachmentsRequest request);

	void deleteIdea(UUID id);
}
