package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.KbArticle;
import ru.loylabs.portal.presentation.request.ChangeKbArticleSectionRequest;
import ru.loylabs.portal.presentation.request.CreateKbArticleRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateKbArticleRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface KbArticleService {
	KbArticle getArticle(UUID sectionId, UUID id);

	Page<KbArticle> getAllArticles(int page, int size, String sort, SearchReversePolishNotation searchCriteria, UUID sectionId);

	Page<KbArticle> getAllArticles(int page, int size, String sort, SearchReversePolishNotation criteria);

	KbArticle saveArticle(UUID sectionId, CreateKbArticleRequest request, Collection<MultipartFile> files);

	KbArticle updateArticle(UUID sectionId, UUID id, UpdateKbArticleRequest request);

	KbArticle moveArticle(UUID sectionId, UUID id, ChangeKbArticleSectionRequest request);

	KbArticle addAttachments(UUID sectionId, UUID id, Collection<MultipartFile> files);

	KbArticle deleteAttachments(UUID sectionId, UUID id, DeleteAttachmentsRequest request);

	void deleteArticle(UUID sectionId, UUID id);
}
