package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.KbSection;
import ru.loylabs.portal.presentation.request.CreateKbSectionRequest;
import ru.loylabs.portal.presentation.request.UpdateKbSectionRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface KbSectionService {
	Page<KbSection> getAllSections(int page, int size, String sort, SearchReversePolishNotation criteria);

	KbSection getSection(UUID id);

	KbSection createSection(CreateKbSectionRequest request);

	KbSection updateSection(UUID id, UpdateKbSectionRequest request);

	void deleteSection(UUID id);

	void checkUnique(String name);

	void checkUnique(String newName, String oldName);

	long countArticles(UUID sectionId);

	Page<KbSection> searchSectionWithRelevantContent(int page, int size, String sort, SearchReversePolishNotation criteria, String searchPhrase);
}
