package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.presentation.request.*;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface PersonService {

	Person getPerson(UUID id);

	Person getByUsername(String username);

	Page<Person> getAllPersons(int page, int size, String sort, SearchReversePolishNotation criteria);

	Person createPerson(CreatePersonRequest request);

	Person createPersonFromYandex(String email);

	Person updatePerson(UpdatePersonRequest request, UUID id);

	Person updatePersonInfo(UpdatePersonInfoRequest request, UUID id);

	Person updateJob(UpdateJobRequest request, UUID id);

	Person updateRole(UpdatePersonRoleRequest request, UUID id);

	Person updateSkills(UpdatePersonSkillsRequest request, UUID id);

	void updatePassword(String password, UUID id);

	void blockPerson(UUID id);

	void unblockPerson(UUID id);

	Person setAvatar(UUID id, MultipartFile file);

	void checkUnique(String username);

	Person setBackground(UUID id, MultipartFile file);

	Page<Person> getAllWithUpcomingBirthdays(int size, int page);

    Person updateStatus(UUID personId, UUID statusId);

	Person deleteStatus(UUID personId);
}
