package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.PersonalBellNotification;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface PersonalBellNotificationService {

	Page<PersonalBellNotification> getAllForPerson(Integer page,
												   Integer size,
												   String sort,
												   SearchReversePolishNotation criteria,
												   UUID personId,
												   boolean seen);

	void markAsSeen(UUID personId, UUID notificationId);

	void markAsSeen(UUID personId, Collection<UUID> notificationIds);

	void markAllAsSeen(UUID personId);

	long countUnseenForPerson(UUID personId);

	void deleteNotificationForPerson(UUID notificationId,UUID personId);

	void deleteAllArchivedNotification(UUID personId);
}
