package ru.loylabs.portal.service.interfaces;

import java.util.Collection;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Attachment;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.RecordType;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;

public interface RecordAdapter {

	Record createRecord(CreateRecordRequest request, Person author, Record parentRecord, RecordType type,
						Collection<MultipartFile> files);

	Record createRecord(CreateRecordRequest request, Person author, Record parentRecord, RecordType type,
						Attachment attachment);

	Record updateRecord(UpdateRecordRequest request, Record record);

	<T extends Record> T addAttachments(T record, Collection<MultipartFile> files);

	<T extends Record> T deleteAttachments(T record, DeleteAttachmentsRequest request);

	<T extends Record> T replaceAttachments(T record, MultipartFile file);

}
