package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.entity.ReviewPersonSkillRating;
import ru.loylabs.portal.presentation.request.CreateReviewPersonSkill;
import ru.loylabs.portal.presentation.request.CreateReviewPersonSkillRating;
import ru.loylabs.portal.presentation.request.UpdateReviewPersonSkill;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.List;
import java.util.UUID;

public interface ReviewPersonService {
	Page<ReviewPersonSkill> getAllReviewPersonSkillByOwner(Integer page, Integer size, String sort,
														   SearchReversePolishNotation criteria, UUID ownerId);
	Page<ReviewPersonSkill> getAllReviewPersonSkillByIdReviewer(Integer page, Integer size, String sort,
																SearchReversePolishNotation criteria,
																UUID reviewerId);
	ReviewPersonSkill getReviewPersonSkillById(UUID id);
	List<ReviewPersonSkillRating> getRatingByReviewId(UUID id);
	ReviewPersonSkill createReview(CreateReviewPersonSkill reviewPersonSkill);

	ReviewPersonSkillRating createRating(UUID reviewId, CreateReviewPersonSkillRating createReviewPersonSkillRating);

	ReviewPersonSkill updateReviewPersonSkill(UUID reviewId, UpdateReviewPersonSkill update);

	void removeReview(UUID reviewId);
}