package ru.loylabs.portal.service.interfaces;

import java.util.UUID;
import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.SecurityRole;
import ru.loylabs.portal.presentation.request.CreateSecurityRoleRequest;
import ru.loylabs.portal.presentation.request.UpdateSecurityRoleRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

public interface SecurityRoleService {

	SecurityRole getRoleById(UUID id);

	SecurityRole getRoleByName(String name);

	Page<SecurityRole> getAllRoles(int page, int size, String sort, SearchReversePolishNotation criteria);

	SecurityRole createRole(CreateSecurityRoleRequest request);

	SecurityRole updateRole(UpdateSecurityRoleRequest request, UUID id);

	void deleteRole(UUID id);

}
