package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.Status;
import ru.loylabs.portal.presentation.request.UpdateStatusRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;
import ru.loylabs.portal.presentation.view.StatusView;

import java.util.UUID;

public interface StatusService {

    Status getStatus(UUID id);

    Status getStatus(String name);

    Page<Status> getAllStatuses(int page, int size, String sort, SearchReversePolishNotation criteria);

    Status createStatus(Status status);

    void deleteStatus(UUID id);

    Status updateStatus(UUID id, UpdateStatusRequest request);
}
