package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.presentation.request.CreateStoryGroupRequest;
import ru.loylabs.portal.presentation.request.CreateStoryRequest;
import ru.loylabs.portal.presentation.request.UpdateStoryGroupRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.List;
import java.util.UUID;

public interface StoryGroupService {
	StoryGroup getStoryGroup(UUID id);

	Page<StoryGroup> getAllStoryGroups(int page, int size, String sort, SearchReversePolishNotation criteria);

	StoryGroup saveStoryGroup(CreateStoryGroupRequest request, Person author, List<CreateStoryRequest> requests, List<MultipartFile> files);

	StoryGroup updateStoryGroup(UpdateStoryGroupRequest request, UUID id);

	void deleteStoryGroup(UUID id);
}
