package ru.loylabs.portal.service.interfaces;

import static ru.loylabs.portal.utility.settings.DynamicSettingsUtils.formMessage;

import java.util.List;
import lombok.RequiredArgsConstructor;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.settings.SettingsTag;
import ru.loylabs.portal.entity.settings.StorySettings;
import ru.loylabs.portal.enums.StoryGroupType;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

public interface StoryManager {

	StorySettingsPack getStorySettingsPack(StoryGroupType groupType);

	@RequiredArgsConstructor
	class StorySettingsPack {

		private final StorySettings settings;

		private final List<SettingsTag> tags;

		public String getGroupHeader() {
			return formMessage(settings.getGroupHeader(), tags);
		}

		public String getGroupContent() {
			return formMessage(settings.getGroupContent(), tags);
		}

		public String getStoryHeader(Person author) {
			return formMessage(settings.getStoryHeader(), tags,
							   new SettingsArgsBuilder().author(author).build());
		}

		public String getStoryContent(Person author) {
			return formMessage(settings.getStoryContent(), tags,
							   new SettingsArgsBuilder().author(author).build());
		}

	}

}
