package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Story;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.presentation.request.CreateStoryRequest;
import ru.loylabs.portal.presentation.request.UpdateStoryRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface StoryService {
	Story getStory(UUID groupId, UUID id);

	Page<Story> getAllStoriesFromGroup(int page, int size, String sort, SearchReversePolishNotation criteria, UUID groupId);

	Story saveStory(CreateStoryRequest request, UUID groupId, Person author, MultipartFile files);

	Story updateStory(UpdateStoryRequest request, UUID groupId, UUID id);

	StoryGroup deleteStory(UUID groupId, UUID id);

	Story replaceStoryAttachment(UUID groupId, UUID id, MultipartFile file);
}
