package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.settings.StorySettings;
import ru.loylabs.portal.enums.StoryGroupType;
import ru.loylabs.portal.presentation.request.settings.CreateStorySettingsRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.UUID;

public interface StorySettingsService {
	StorySettings getCurrentSettings(StoryGroupType type);

	StorySettings getSettings(UUID id);

	Page<StorySettings> getAllSettings(int page, int size, String sort, SearchReversePolishNotation criteria);

	StorySettings createSettings(CreateStorySettingsRequest request, StoryGroupType storyGroupType);
}
