package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Task;
import ru.loylabs.portal.enums.TaskStatus;
import ru.loylabs.portal.presentation.request.CreateTaskRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateTaskRequest;
import ru.loylabs.portal.presentation.request.UpdateTaskSequenceStatusRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface TaskService {

	Page<Task> getAllTasks(UUID id, int page, int size, String sort, SearchReversePolishNotation searchCriteria);

	Task getTask(UUID achievementId, UUID taskId);

	Task createTask(CreateTaskRequest request, UUID achievementId, Collection<MultipartFile> files, Person author);

	Task updateTask(UpdateTaskRequest request, UUID achievementId, UUID taskId, Person updateBy);

	Task updateTaskStatusAndSequence(UpdateTaskSequenceStatusRequest request, UUID achievementId, UUID taskId,Person updateBy);

	Task updateTaskStatus(UUID achievementId, UUID id, TaskStatus status,Person updateBy);

	void deleteTask(UUID achievementId, UUID id);

	Task addAttachments(UUID achievementId, UUID taskId, Collection<MultipartFile> files);

	Task deleteAttachments(UUID achievementId, UUID taskId, DeleteAttachmentsRequest request);
}
