package ru.loylabs.portal.service.interfaces;

import org.springframework.data.domain.Page;
import ru.loylabs.portal.entity.TaskTag;
import ru.loylabs.portal.presentation.request.CreateTaskTagRequest;
import ru.loylabs.portal.presentation.request.UpdateTaskTagRequest;
import ru.loylabs.portal.presentation.search.SearchReversePolishNotation;

import java.util.Collection;
import java.util.UUID;

public interface TaskTagService {

	Page<TaskTag> getTagsInAchievement(int page, int size, String sort, SearchReversePolishNotation criteria, UUID achievementId);

	TaskTag getTaskTag(UUID tagId);

	TaskTag createTaskTag(UUID achievementId, CreateTaskTagRequest request);

	TaskTag updateTaskTag(UUID achievementId, UUID tagId, UpdateTaskTagRequest request);

	void deleteTaskTag(UUID achievementId, UUID tagId);

	void addTagsOnTask(UUID achievementId, UUID taskId, Collection<UUID> tagIds);

	void deleteTagFromTask(UUID achievementId, UUID taskId, UUID tagId);
}
