package ru.loylabs.portal.service.interfaces;

import java.util.Optional;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.service.yandex.dto.Yandex360UserPageResponse;
import ru.loylabs.portal.service.yandex.dto.Yandex360UserResponse;

public interface Yandex360UserService {

	Yandex360UserResponse getYandexUser(String id);

	Yandex360UserPageResponse getAllYandexUsers(Pageable pageable);

	default Yandex360UserPageResponse getAllYandexUsers(int page, int size) {
		return getAllYandexUsers(PageRequest.of(page, size));
	}

	Yandex360UserResponse createYandexUser(Person person);

	Yandex360UserResponse updateYandexUser(Person person);

	Optional<Yandex360UserResponse> findByEmail(String email);

}
