package ru.loylabs.portal.service.notification.bell;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.entity.BellNotification;
import ru.loylabs.portal.service.notification.bell.data.NotificationData;
import ru.loylabs.portal.service.interfaces.BellNotificationFactory;
import ru.loylabs.portal.service.interfaces.BellNotificationManager;

import java.time.Instant;

@Component
@RequiredArgsConstructor
public class BellNotificationFactoryImpl implements BellNotificationFactory {

	private final BellNotificationManager notificationManager;

	@Override
	public BellNotification create(NotificationData notificationData) {
		var fields = notificationData.initFieldsPack();
		var settingsPack = notificationManager.getNotificationSettingsPack(fields.getType());

		return new BellNotification(
				fields.getSender(),
				Instant.now(),
				settingsPack.getMessageTitle(),
				settingsPack.getMessage(fields.getArgs()),
				fields.getType(),
				fields.getUri(),
				fields.getSubjectId()
		);
	}

}
