package ru.loylabs.portal.service.notification.bell;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.service.interfaces.BellNotificationManager;
import ru.loylabs.portal.service.interfaces.BellNotificationSettingsService;
import ru.loylabs.portal.service.interfaces.SettingsTagService;

@Component
@RequiredArgsConstructor
public class BellNotificationManagerImpl implements BellNotificationManager {

	private final BellNotificationSettingsService notificationSettingsService;

	private final SettingsTagService settingsTagService;

	@Override
	public BellNotificationSettingsPack getNotificationSettingsPack(BellNotificationType notificationType) {
		return new BellNotificationSettingsPack(
				notificationSettingsService.getCurrentSettings(notificationType),
				settingsTagService.getAllowedTagsForType(notificationType)
		);
	}

}
