package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.ACHIEVEMENTS_URI;
import static ru.loylabs.portal.config.URIConstants.ACHIEVEMENT_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.enums.BellNotificationType.ACHIEVEMENT_CONFIRMED;

@Value
@EqualsAndHashCode(callSuper = false)
public class AchievementConfirmNotificationData extends NotificationData {

	static final String path = "/profile" + PERSON_ID_URI_PARAM + ACHIEVEMENTS_URI + ACHIEVEMENT_ID_URI_PARAM;
	Achievement achievement;
	Person confirming;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(achievement.getOwner().getId(), achievement.getId())
				.toString();

		var args = new SettingsArgsBuilder()
				.author(confirming)
				.achievement(achievement)
				.build();

		return new FieldsPack(confirming, args, ACHIEVEMENT_CONFIRMED, uri, achievement.getId());
	}
}
