package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Community;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.COMMUNITY_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.COMMUNITY_URI;
import static ru.loylabs.portal.enums.BellNotificationType.COMMUNITY_NEW_RECORD;

@Value
@EqualsAndHashCode(callSuper = false)
public class CommunityRecordCreateNotificationData extends NotificationData {

	static final String path = COMMUNITY_URI + COMMUNITY_ID_URI_PARAM;

	Community community;
	Record record;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(community.getId())
				.toString();
		var args = new SettingsArgsBuilder()
				.author(record.getAuthor())
				.community(community)
				.record(record)
				.build();

		return new FieldsPack(record.getAuthor(), args, COMMUNITY_NEW_RECORD, uri, record.getId());
	}
}
