package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Feed;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.FEED_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.FEED_URI;

@Value
@EqualsAndHashCode(callSuper = false)
public class FeedCreateNotificationData extends NotificationData {

	static final String path = FEED_URI + FEED_ID_URI_PARAM;
	Feed feed;


	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path).expand(feed.getId()).toString();
		var args = new SettingsArgsBuilder()
				.author(feed.getAuthor())
				.feed(feed)
				.build();

		return new FieldsPack(feed.getAuthor(), args, BellNotificationType.FEED_NEW, uri, feed.getId());
	}
}
