package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.IDEAS_URI;
import static ru.loylabs.portal.config.URIConstants.IDEA_ID_URI_PARAM;

@Value
@EqualsAndHashCode(callSuper = false)
public class IdeaCommentNotificationData extends NotificationData {

	static final String path = IDEAS_URI + IDEA_ID_URI_PARAM;
	Idea idea;
	Record comment;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path).expand(idea.getId()).toString();
		var args = new SettingsArgsBuilder()
				.author(comment.getAuthor())
				.idea(idea)
				.record(comment)
				.build();

		return new FieldsPack(comment.getAuthor(), args, BellNotificationType.IDEA_COMMENT, uri, comment.getId());
	}
}
