package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Idea;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.IDEAS_URI;
import static ru.loylabs.portal.config.URIConstants.IDEA_ID_URI_PARAM;

@Value
@EqualsAndHashCode(callSuper = false)
public class IdeaCreateNotificationData extends NotificationData {

	static final String path = IDEAS_URI + IDEA_ID_URI_PARAM;
	Idea idea;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(idea.getId())
				.toString();
		var args = new SettingsArgsBuilder()
				.author(idea.getAuthor())
				.idea(idea)
				.build();

		return new FieldsPack(idea.getAuthor(), args, BellNotificationType.IDEA_NEW, uri, idea.getId());
	}
}
