package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.enums.BellNotificationType.PERSON_DOB_NOT_SPECIFIED;

@Value
@EqualsAndHashCode(callSuper = false)
public class PersonDobNotSpecifiedNotificationData extends NotificationData {

	final static String path = "/profile" + PERSON_ID_URI_PARAM;
	Person person;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(person.getId())
				.toString();

		var args = new SettingsArgsBuilder()
				.author(person)
				.build();
		return new FieldsPack(null, args, PERSON_DOB_NOT_SPECIFIED, uri, person.getId());
	}
}
