package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.enums.BellNotificationType.PERSON_HAS_REGISTERED;

@Value
@EqualsAndHashCode(callSuper = false)
public class PersonHasRegisteredNotificationData extends NotificationData {

	final static String path = "/profile" + PERSON_ID_URI_PARAM;
	Person person;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(person.getId())
				.toString();
		var args = new SettingsArgsBuilder()
				.target(person)
				.build();

		return new FieldsPack(person, args, PERSON_HAS_REGISTERED, uri, person.getId());
	}
}