package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Reviewers;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.REVIEW_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.REVIEW_URI;
import static ru.loylabs.portal.enums.BellNotificationType.CREATE_REVIEW;

@Value
@EqualsAndHashCode(callSuper = false)
public class ReviewCreateNotificationData extends NotificationData {
	static final String path = "/profile" + PERSON_ID_URI_PARAM + REVIEW_URI + REVIEW_ID_URI_PARAM;
	Reviewers reviewers;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(reviewers.getReview().getOwner().getId(), reviewers.getReview().getId())
				.toString();

		var args = new SettingsArgsBuilder()
				.author(reviewers.getReview().getOwner())
				.reviewSkill(reviewers.getReview().getSkill())
				.reviewEndDate(reviewers.getReview().getEndReview())
				.build();

		return new FieldsPack(reviewers.getReview().getOwner(), args, CREATE_REVIEW, uri, reviewers.getReviewer().getId());
	}
}
