package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.ReviewPersonSkill;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.REVIEW_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.REVIEW_URI;
import static ru.loylabs.portal.enums.BellNotificationType.OWNER_NEW_REVIEW;

@Value
@EqualsAndHashCode(callSuper = false)
public class ReviewCreateOwnerNotificationData extends NotificationData {
	static final String path = "/profile" + PERSON_ID_URI_PARAM + REVIEW_URI + REVIEW_ID_URI_PARAM;
	ReviewPersonSkill review;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(review.getOwner().getId(), review.getId())
				.toString();

		var args = new SettingsArgsBuilder()
				.reviewSkill(review.getSkill())
				.reviewEndDate(review.getEndReview())
				.build();

		return new FieldsPack(null, args, OWNER_NEW_REVIEW, uri, review.getOwner().getId());
	}
}
