package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.StoryGroup;
import ru.loylabs.portal.enums.BellNotificationType;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

@Value
@EqualsAndHashCode(callSuper = false)
public class StoryGroupCreateNotificationData extends NotificationData {

	final static String path = "/feed?story={storyGroupId}";
	StoryGroup storyGroup;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(storyGroup.getId())
				.toString();
		var args = new SettingsArgsBuilder()
				.author(storyGroup.getAuthor())
				.build();

		return new FieldsPack(storyGroup.getAuthor(), args, BellNotificationType.STORY_GROUP_NEW,uri,storyGroup.getId());
	}
}
