package ru.loylabs.portal.service.notification.bell.data;

import lombok.EqualsAndHashCode;
import lombok.Value;
import org.springframework.web.util.UriTemplate;
import ru.loylabs.portal.entity.Achievement;
import ru.loylabs.portal.entity.Task;
import ru.loylabs.portal.utility.settings.SettingsArgsBuilder;

import static ru.loylabs.portal.config.URIConstants.ACHIEVEMENTS_URI;
import static ru.loylabs.portal.config.URIConstants.ACHIEVEMENT_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.PERSON_ID_URI_PARAM;
import static ru.loylabs.portal.config.URIConstants.TASKS_URI;
import static ru.loylabs.portal.config.URIConstants.TASK_ID_URI_PARAM;
import static ru.loylabs.portal.enums.BellNotificationType.TASK_DONE;

@Value
@EqualsAndHashCode(callSuper = false)
public class TaskDoneNotificationData extends NotificationData {

	static final String path = "/profile"
			+ PERSON_ID_URI_PARAM
			+ ACHIEVEMENTS_URI
			+ ACHIEVEMENT_ID_URI_PARAM
			+ TASKS_URI
			+ TASK_ID_URI_PARAM;
	Achievement achievement;
	Task task;

	@Override
	public FieldsPack initFieldsPack() {
		var uri = new UriTemplate(path)
				.expand(achievement.getOwner().getId(), achievement.getId(), task.getId())
				.toString();
		var args = new SettingsArgsBuilder()
				.author(achievement.getOwner())
				.achievement(achievement)
				.task(task)
				.build();

		return new FieldsPack(achievement.getOwner(), args, TASK_DONE, uri, task.getId());
	}
}
