package ru.loylabs.portal.service.notification.email;

import java.util.Collection;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.web.multipart.MultipartFile;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.enums.EmailNotificationType;
import ru.loylabs.portal.service.interfaces.Notification;
import ru.loylabs.portal.utility.EmailEmbeddableFile;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class EmailNotification implements Notification<EmailNotificationType> {

	private EmailNotificationType notificationType;

	private String header;

	private String content;

	private Collection<Person> receivers;

	private Collection<String> receiverEmails;

	private Collection<MultipartFile> files;

	private Collection<EmailEmbeddableFile> embeddableFiles;

}
