package ru.loylabs.portal.service.notification.email;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.enums.EmailNotificationType;
import ru.loylabs.portal.service.interfaces.EmailNotificationManager;
import ru.loylabs.portal.service.interfaces.EmailNotificationSettingsService;
import ru.loylabs.portal.service.interfaces.SettingsTagService;

@Component
@RequiredArgsConstructor
public class EmailNotificationManagerImpl implements EmailNotificationManager {

	private final EmailNotificationSettingsService notificationSettingsService;

	private final SettingsTagService settingsTagService;

	@Override
	public EmailNotificationSettingsPack getNotificationSettingsPack(EmailNotificationType notificationType) {
		return new EmailNotificationSettingsPack(
				notificationSettingsService.getCurrentSettings(notificationType),
				settingsTagService.getAllowedTagsForType(notificationType)
		);
	}

}
