package ru.loylabs.portal.service.output.email;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.service.interfaces.EmailAdapter;
import ru.loylabs.portal.service.interfaces.NotificationSender;
import ru.loylabs.portal.service.notification.email.EmailNotification;

import static ru.loylabs.portal.utility.CollectionUtils.isValid;

@Component
@RequiredArgsConstructor
public class EmailNotificationSenderImpl implements NotificationSender<EmailNotification> {

	private final EmailAdapter emailAdapter;

	@Override
	public void send(EmailNotification notification) {
		// TODO
		if (isValid(notification.getReceivers()))
			for (Person receiver : notification.getReceivers()) {
				emailAdapter.sendMimeMessage(
						receiver.getUsername(),
						notification.getHeader(),
						notification.getContent(),
						notification.getFiles(),
						notification.getEmbeddableFiles()
				);
			}

		// Workaround for Bug reports. Also allows to send to emails other than ones specified in Person.
		if (isValid(notification.getReceiverEmails()))
			for (String receiverEmail : notification.getReceiverEmails()) {
				emailAdapter.sendMimeMessage(
						receiverEmail,
						notification.getHeader(),
						notification.getContent(),
						notification.getFiles(),
						notification.getEmbeddableFiles()
				);
			}
	}

}
