package ru.loylabs.portal.service.security;

import lombok.RequiredArgsConstructor;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.repository.PersonRepository;

@Service
@RequiredArgsConstructor
public class CredentialService implements UserDetailsService {

	private final PersonRepository personRepository;

	@Override
	public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
		return new Credential(personRepository.findByUsername(username).orElseThrow(() -> new UsernameNotFoundException(username)));
	}
}
