package ru.loylabs.portal.service.security.password.rules;

import lombok.Getter;

@Getter
public class NoWhitespacePasswordRule implements PasswordRule {

	private final String errorMessage;

	public NoWhitespacePasswordRule() {
		this.errorMessage = "Password cannot have whitespace characters";
	}

	@Override
	public boolean apply(char[] rawChars) {
		int count = 0;
		for (Character chara : rawChars)
			if (Character.isWhitespace(chara)) return false;
		return true;
	}

	@Override
	public String getErrorMessage() {
		return errorMessage;
	}

}
