package ru.loylabs.portal.service.story.data;

import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Component;
import ru.loylabs.portal.enums.StoryGroupType;
import ru.loylabs.portal.service.interfaces.SettingsTagService;
import ru.loylabs.portal.service.interfaces.StoryManager;
import ru.loylabs.portal.service.interfaces.StorySettingsService;

@Component
@RequiredArgsConstructor
public class StoryManagerImpl implements StoryManager {
	private final StorySettingsService storySettingsService;
	private final SettingsTagService settingsTagService;

	@Override
	public StorySettingsPack getStorySettingsPack(StoryGroupType groupType) {
		return new StorySettingsPack(storySettingsService.getCurrentSettings(groupType), settingsTagService.getAllTags());
	}
}
