package ru.loylabs.portal.service.telegram.reader;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;
import java.util.Map;

@Setter
@Getter
@JsonIgnoreProperties(ignoreUnknown = true)
public class ArticleContent {
    @JsonProperty("blocks")
    private List<Block> blocks;
    @JsonProperty("entityMap")
    private Map<Integer, Entity> entityMap;

    @Setter
    @Getter
    @JsonIgnoreProperties(ignoreUnknown = true)
    public static class Block{
        @JsonProperty("text")
        private String text;
    }
    @Setter
    @Getter
    @JsonIgnoreProperties(ignoreUnknown = true)
    @AllArgsConstructor
    @NoArgsConstructor
    public static class Entity{
        @JsonProperty("data")
        private Data data;

        @Setter
        @Getter
        @JsonIgnoreProperties(ignoreUnknown = true)
        @AllArgsConstructor
        @NoArgsConstructor
        public static class Data{
            private String url;
        }
    }
}
