package ru.loylabs.portal.service.yandex;

import java.util.Optional;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.service.interfaces.Yandex360UserService;
import ru.loylabs.portal.service.yandex.dto.Yandex360UserPageResponse;
import ru.loylabs.portal.service.yandex.dto.Yandex360UserResponse;

@Service
public class NoOpYandex360UserServiceImpl implements Yandex360UserService {

	@Override
	public Yandex360UserResponse getYandexUser(String id) {
		return Yandex360UserResponse.EMPTY;
	}

	@Override
	public Yandex360UserPageResponse getAllYandexUsers(Pageable pageable) {
		return Yandex360UserPageResponse.EMPTY;
	}

	@Override
	public Yandex360UserResponse createYandexUser(Person person) {
		return Yandex360UserResponse.EMPTY;
	}

	@Override
	public Yandex360UserResponse updateYandexUser(Person person) {
		return Yandex360UserResponse.EMPTY;
	}

	@Override
	public Optional<Yandex360UserResponse> findByEmail(String email) {
		return Optional.empty();
	}

	@Override
	public Yandex360UserPageResponse getAllYandexUsers(int page, int size) {
		return Yandex360UserPageResponse.EMPTY;
	}

}
