package ru.loylabs.portal.service.yandex.dto;

import java.io.Serial;
import java.io.Serializable;
import java.time.LocalDate;
import java.util.List;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonInclude;
import ru.loylabs.portal.utility.DateTimeFormatUtil;

@Data
@NoArgsConstructor
@AllArgsConstructor
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class Yandex360UpdateUserRequest implements Serializable {

	@Serial
	private static final long serialVersionUID = 1L;

	private String externalId;

	private Boolean isAdmin;

	private Boolean isEnabled;

	private Yandex360UserNameRequest name;

	private String password;

	private Boolean passwordChangeRequired;

	private String gender;

	@JsonFormat(pattern = DateTimeFormatUtil.ISO_LOCAL_DATE_FORMAT)
	private LocalDate birthday;

	private String about;

	private List<Yandex360UserContactRequest> contacts;

	private Integer departmentId;

	private String position;

	private String language;

	private String timezone;

}
