package ru.loylabs.portal.service.yandex.dto;

import java.io.Serial;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import org.springframework.data.domain.PageRequest;

@NoArgsConstructor
@ToString(callSuper = true)
@EqualsAndHashCode(callSuper = true)
public class Yandex360UserPageResponse extends Yandex360AbstractPageResponse<Yandex360UserResponse> {

	@Serial
	private static final long serialVersionUID = 1L;

	public static final Yandex360UserPageResponse EMPTY;

	static {
		EMPTY = new Yandex360UserPageResponse();
		EMPTY.setPage(1);
		EMPTY.setPages(1);
		EMPTY.setPerPage(10);
		EMPTY.setTotal(0);
		EMPTY.setUsers(Collections.emptyList());
	}

	@Getter
	@Setter
	private List<Yandex360UserResponse> users;

	public Yandex360UserPageResponse(Integer page,
									 Integer pages,
									 Integer perPage,
									 Integer total,
									 List<Yandex360UserResponse> users) {
		super(page, pages, perPage, total);
		this.users = users;
	}

	@Override
	public int getTotalPages() {
		return pages;
	}

	@Override
	public long getTotalElements() {
		return total;
	}

	@Override
	public List<Yandex360UserResponse> getContent() {
		return users;
	}

	@Override
	public boolean hasContent() {
		return !users.isEmpty();
	}

	@Override
	public boolean hasNext() {
		return getNumber() + 1 < getTotalPages();
	}

	@Override
	public Iterator<Yandex360UserResponse> iterator() {
		return users.iterator();
	}

}
