package ru.loylabs.portal.service.yandex.dto;

import java.io.Serial;
import java.io.Serializable;
import java.time.Instant;
import java.time.LocalDate;
import java.util.List;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import ru.loylabs.portal.utility.DateTimeFormatUtil;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class Yandex360UserResponse implements Serializable {

	@Serial
	private static final long serialVersionUID = 1L;

	public static final Yandex360UserResponse EMPTY;

	static {
		EMPTY = new Yandex360UserResponse();
	}

	private String id;

	private String externalId;

	private Instant createdAt;

	private Instant updatedAt;

	private Boolean isAdmin;

	private Boolean isDismissed;

	private Boolean isEnabled;

	private Boolean isRobot;

	private Yandex360UserNameResponse name;

	private List<String> aliases;

	private String nickname;

	private String gender;

	@JsonFormat(pattern = DateTimeFormatUtil.ISO_LOCAL_DATE_FORMAT)
	private LocalDate birthday;

	private String about;

	private String email;

	private List<Yandex360UserContactResponse> contacts;

	private Integer departmentId;

	private String position;

	private List<Integer> groups;

	private String language;

	private String timezone;

	private String avatarId;

	@JsonIgnore
	public String getFirstName() {
		return name == null ? null : name.getFirst();
	}

	@JsonIgnore
	public String getLastName() {
		return name == null ? null : name.getLast();
	}

	@JsonIgnore
	public String getMiddleName() {
		return name == null ? null : name.getMiddle();
	}

}
