package ru.loylabs.portal.utility;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.util.Base64;

@Slf4j
public class CryptoUtil {
	@Value("${crypto.key}")
	private static String key;
	@Value("${crypto.algorithm}")
	private static String algorithm;

	public static String encrypt(String input) {
		try {
			Cipher cipher = Cipher.getInstance(algorithm);
			cipher.init(Cipher.ENCRYPT_MODE, new SecretKeySpec(key.getBytes(), algorithm));
			byte[] cipherText = cipher.doFinal(input.getBytes());
			return Base64.getEncoder().encodeToString(cipherText);
		} catch (Exception e) {
			log.error("Encryption error: {}", e.getMessage());
			return "";
		}
	}

	public static String decrypt(String cipherText) {
		try {
			Cipher cipher = Cipher.getInstance(algorithm);
			cipher.init(Cipher.DECRYPT_MODE, new SecretKeySpec(key.getBytes(), algorithm));
			byte[] plainText = cipher.doFinal(Base64.getDecoder().decode(cipherText));
			return new String(plainText);
		} catch (Exception e) {
			log.error("Encryption error: {}", e.getMessage());
			return "";
		}
	}
}
