package ru.loylabs.portal.utility;

import ru.loylabs.portal.enums.AttachmentType;

public class FileAttachmentTypeFactory {
	public static AttachmentType getCorrespondingType(String contentType) {
		if (contentType == null) return AttachmentType.FILE;
		return switch (contentType) {
			case "image/gif", "image/jpeg", "image/pjpeg", "image/png", "image/svg+xml", "image/tiff", "image/vnd.microsoft.icon", "image/vnd.wap.wbmp", "image/webp" ->
					AttachmentType.IMAGE;
			case "text/cmd", "text/css", "text/csv", "text/html", "text/javascript", "text/plain", "text/php", "text/xml", "text/markdown", "text/cache-manifest" ->
					AttachmentType.DOCUMENT;
			case "video/mpeg", "video/mp4", "video/ogg", "video/quicktime", "video/webm", "video/x-ms-wmv", "video/x-flv", "video/x-msvideo", "video/3gpp", "video/3gpp2", "audio/basic", "audio/L24", "audio/mp4", "audio/aac", "audio/mpeg", "audio/ogg", "audio/vorbis", "audio/x-ms-wma", "audio/x-ms-wax", "audio/vnd.rn-realaudio", "audio/vnd.wave", "audio/webm" ->
					AttachmentType.MEDIA;
			default -> AttachmentType.FILE;
		};
	}
}
