package ru.loylabs.portal.utility;

import static java.util.Objects.nonNull;

public enum StringUtils {

	;

	/**
	 * Checks {@link String} validity.
	 *
	 * @param string {@link String} instance to check
	 *
	 * @return {@literal true} if {@code string} provided is both non-null and not blank, {@literal false} otherwise
	 */
	public static boolean isValid(String string) {
		return nonNull(string) && !string.isBlank();
	}

	/**
	 * Checks {@link String} invalidity.
	 *
	 * @param string {@link String} instance to check
	 *
	 * @return {@literal true} if {@code string} provided is either null or blank, {@literal false} otherwise
	 */
	public static boolean isInvalid(String string) {
		return !isValid(string);
	}

}
