package ru.loylabs.portal.utility.settings;

import java.util.Collections;
import java.util.List;
import java.util.Map;
import ru.loylabs.portal.entity.settings.SettingsTag;
import ru.loylabs.portal.enums.SettingsTagType;


public class DynamicSettingsUtils {

	public static String formMessage(String messagePattern, List<SettingsTag> tags) {
		return formMessage(messagePattern, tags, Collections.emptyMap());
	}

	public static String formMessage(String messagePattern,
									 List<SettingsTag> tags,
									 Map<SettingsTagType, String> args) {
		for (SettingsTag tag : tags)
			messagePattern = messagePattern.replaceAll(
					tag.getTag(), args.getOrDefault(tag.getCode(), "")
			);

		return messagePattern;
	}

}
