create type story_group_type as enum ('BIRTHDAY', 'WELCOME', 'ADMIN');
create type story_type as enum ('MAIN', 'BIRTHDAY', 'WELCOME', 'DEFAULT');

alter type record_type add value 'STORY';

drop table if exists story_attachment;
drop table if exists story;
drop table if exists stories;

create table if not exists story_group
(
    id          uuid primary key,
    pinned      bool             not null,
    update_time timestamp        not null,
    group_type  story_group_type not null,
    author_id   uuid references person (id)
);

create table if not exists story
(
    id          uuid primary key references record (id),
    header      varchar   not null,
    expire_time timestamp not null
);

create table if not exists story_group_story
(
    story_id       uuid not null references story (id),
    story_group_id uuid not null references story_group (id),
    unique (story_id, story_group_id)
);

alter type credential_permission add VALUE 'STORY_VIEW_ALL_STORY_GROUPS';
alter type credential_permission add VALUE 'STORY_VIEW_ONE_STORY_GROUP';
alter type credential_permission add VALUE 'STORY_CREATE_STORY_GROUP';
alter type credential_permission add VALUE 'STORY_UPDATE_STORY_GROUP';
alter type credential_permission add VALUE 'STORY_DELETE_STORY_GROUP';
alter type credential_permission add VALUE 'STORY_VIEW_ALL_STORIES';
alter type credential_permission add VALUE 'STORY_VIEW_ONE_STORY';
alter type credential_permission add VALUE 'STORY_CREATE_STORY';
alter type credential_permission add VALUE 'STORY_UPDATE_STORY';
alter type credential_permission add VALUE 'STORY_DELETE_STORY';