create type achievement_status as enum ('NEW', 'ARCHIVED', 'DONE');
create type task_status as enum ('IN_PROGRESS', 'NEED_REVIEW', 'DONE');
alter type record_type add VALUE 'TASK';

DROP TABLE if exists task_attachment;

truncate achievement, record cascade;

ALTER TABLE achievement
drop column if exists person_id,
drop column if exists done,
drop column if exists archived,
add column if not exists status achievement_status not null,
alter column supervisor_id drop not null;

ALTER TABLE task
drop column if exists done,
add column if not exists status task_status not null;

ALTER TABLE record alter column content drop not null;

alter type credential_permission add VALUE 'ACHIEVEMENT_CREATE';
alter type credential_permission add VALUE 'ACHIEVEMENT_UPDATE';
alter type credential_permission add VALUE 'ACHIEVEMENT_DELETE';
alter type credential_permission add VALUE 'ACHIEVEMENT_REVIEW';
alter type credential_permission add VALUE 'ACHIEVEMENT_ARCHIVING';
alter type credential_permission add VALUE 'ACHIEVEMENT_CONFIRM';
alter type credential_permission add VALUE 'ACHIEVEMENTS_VEW_ALL_ACHIEVEMENTS';
alter type credential_permission add VALUE 'TASK_CREATE';
alter type credential_permission add VALUE 'TASK_UPDATE';
alter type credential_permission add VALUE 'TASK_DELETE';
alter type credential_permission add VALUE 'TASK_CONFIRM';
alter type credential_permission add VALUE 'TASK_REFUSING';
alter type credential_permission add VALUE 'TASK_REVIEWING';
alter type credential_permission add VALUE 'TASK_MAKE_COMMENT';