create table smile
(
    id     uuid primary key,
    symbol varchar(255) not null
);

create table emoji
(
    id          uuid primary key,
    reaction_id uuid references reaction (id),
    smile_id    uuid references smile (id),
    unique (reaction_id, smile_id)
);

create table emoji_person
(
    id        uuid primary key,
    emoji_id  uuid not null references emoji (id),
    person_id uuid not null references person (id),
    unique (emoji_id, person_id)
);

alter table reaction
    drop column like_count;
alter table reaction
    drop column dislike_count;
alter table reaction
    drop column emoji;

alter type credential_permission add VALUE 'REACTION_VIEW_ALL_SMILES' after 'ACHIEVEMENT_DELETE';
alter type credential_permission add VALUE 'REACTION_VIEW_ALL_EMOJI' after 'REACTION_VIEW_ALL_SMILES';
alter type credential_permission add VALUE 'REACTION_ADD_EMOJI' after 'REACTION_VIEW_ALL_EMOJI';
alter type credential_permission add VALUE 'REACTION_REMOVE_EMOJI' after 'REACTION_ADD_EMOJI';