DROP TYPE department cascade;
DROP TYPE title cascade;

CREATE TABLE if not exists department
(
    id   uuid primary key default uuid_generate_v4(),
    name varchar not null unique
);

CREATE TABLE if not exists title
(
    id   uuid primary key default uuid_generate_v4(),
    name varchar not null unique
);

TRUNCATE TABLE job CASCADE;

ALTER TABLE job
    add column department uuid not null references department (id),
    add column title      uuid not null references title (id);


ALTER TYPE credential_permission ADD VALUE 'TITLE_CREATE';
ALTER TYPE credential_permission ADD VALUE 'TITLE_UPDATE';
ALTER TYPE credential_permission ADD VALUE 'TITLE_DELETE';
ALTER TYPE credential_permission ADD VALUE 'TITLE_GET_ALL';
ALTER TYPE credential_permission ADD VALUE 'DEPARTMENT_CREATE';
ALTER TYPE credential_permission ADD VALUE 'DEPARTMENT_UPDATE';
ALTER TYPE credential_permission ADD VALUE 'DEPARTMENT_DELETE';
ALTER TYPE credential_permission ADD VALUE 'DEPARTMENT_GET_ALL';
ALTER TYPE credential_permission ADD VALUE 'EMPLOYEE_CHANGE_JOB' AFTER 'EMPLOYEE_CHANGE_PERSON';