create table if not exists task_tag
(
    id             uuid primary key default uuid_generate_v4(),
    name           varchar not null,
    color          varchar not null,
    achievement_id uuid    not null references achievement (id),
    unique (name, color)
);

create table if not exists task_tag_task
(
    task_id     uuid references task (id),
    task_tag_id uuid references task_tag (id),
    unique (task_id, task_tag_id)
);

alter type credential_permission add value if not exists 'ACHIEVEMENT_UNARCHIVING' after 'ACHIEVEMENT_ARCHIVING';
alter type credential_permission add value if not exists 'TASK_TAG_VIEW_ALL_TAG' after 'TASK_DELETE';
alter type credential_permission add value if not exists 'TASK_TAG_CREATE_TAG' after 'TASK_TAG_VIEW_ALL_TAG';
alter type credential_permission add value if not exists 'TASK_TAG_UPDATE_TAG' after 'TASK_TAG_CREATE_TAG';
alter type credential_permission add value if not exists 'TASK_TAG_DELETE_TAG' after 'TASK_TAG_UPDATE_TAG';
alter type credential_permission add value if not exists 'TASK_TAG_MARK_TASK' after 'TASK_TAG_DELETE_TAG';
alter type credential_permission add value if not exists 'TASK_TAG_UNMARK_TASK' after 'TASK_TAG_MARK_TASK';

