truncate table bell_notification cascade;
alter table bell_notification
    drop constraint bell_notification_id_fkey,
    drop column header,
    drop column link;

alter table personal_bell_notification
    rename to bell_notification_personal;

alter table bell_notification
    alter column id set default uuid_generate_v4(),
    add column author_id uuid references person (id),
    add column header    varchar   not null,
    add column content   varchar   not null,
    add column link      varchar,
    add column date      timestamp not null;


alter type bell_notification_type rename value 'REACTION' to 'FEED_NEW';
alter type bell_notification_type rename value 'NEW_IDEA' to 'IDEA_NEW';
alter type bell_notification_type rename value 'COMMENT' to 'IDEA_COMMENT';
alter type bell_notification_type rename value 'NEW_STORY' to 'STORY_GROUP_NEW';
alter type bell_notification_type rename value 'TASK_APPROVAL' to 'FEED_COMMENT';
alter type bell_notification_type rename value 'GROUP_RECORD' to 'COMMUNITY_NEW_RECORD';
alter type bell_notification_type rename value 'CALENDAR_EVENT' to 'CALENDAR_NEW_EVENT';
alter type bell_notification_type rename value 'GENERATED_YANDEX_ACCOUNT_PASSWORD' to 'YANDEX_ACCOUNT_GENERATED_PASSWORD';


alter type settings_tag_type add value 'IDEA_HEADER';
alter type settings_tag_type add value 'FEED_CONTENT';
alter type settings_tag_type add value 'CALENDAR_EVENT_DATE';