
ALTER TABLE security_permission DROP COLUMN permission;

DROP TYPE IF EXISTS credential_permission;

CREATE TYPE credential_permission AS ENUM ('ACHIEVEMENT_READ',
                                           'ACHIEVEMENT_READ_OWN',
                                           'ACHIEVEMENT_WRITE',
                                           'ACHIEVEMENT_WRITE_OWN',
                                           'ACHIEVEMENT_APPROVAL',
                                           'ACHIEVEMENT_ARCHIVE',
                                           'ACHIEVEMENT_UNARCHIVE',
                                           'COMMENT_READ_ATTACHMENT',
                                           'COMMENT_WRITE_ATTACHMENT',
                                           'COMMENT_WRITE_OWN_ATTACHMENT',
                                           'BUG_REPORT_READ',
                                           'BUG_REPORT_WRITE',
                                           'BUG_REPORT_READ_COMMENT',
                                           'BUG_REPORT_WRITE_COMMENT',
                                           'BUG_REPORT_WRITE_OWN_COMMENT',
                                           'BUG_REPORT_READ_ATTACHMENT',
                                           'BUG_REPORT_WRITE_ATTACHMENT',
                                           'BUG_REPORT_WRITE_OWN_ATTACHMENT',
                                           'CALENDAR_READ_WORKING',
                                           'CALENDAR_READ_CORPORATE',
                                           'CALENDAR_WRITE_CORPORATE',
                                           'CALENDAR_READ_YANDEX',
                                           'CALENDAR_WRITE_YANDEX',
                                           'DEPARTMENT_READ',
                                           'DEPARTMENT_WRITE',
                                           'FEED_READ',
                                           'FEED_CREATE_GENERAL',
                                           'FEED_CREATE_IMPORTANT',
                                           'FEED_MODIFY',
                                           'FEED_MODIFY_OWN',
                                           'FEED_READ_COMMENT',
                                           'FEED_WRITE_COMMENT',
                                           'FEED_WRITE_OWN_COMMENT',
                                           'FEED_READ_ATTACHMENT',
                                           'FEED_WRITE_ATTACHMENT',
                                           'FEED_WRITE_OWN_ATTACHMENT',
                                           'FILE_READ',
                                           'FILE_WRITE',
                                           'COMMUNITY_READ',
                                           'COMMUNITY_READ_OWN',
                                           'COMMUNITY_READ_PUBLIC',
                                           'COMMUNITY_JOIN_LEAVE',
                                           'COMMUNITY_WRITE',
                                           'COMMUNITY_WRITE_OWN',
                                           'COMMUNITY_INVITE_KICK',
                                           'COMMUNITY_INVITE_KICK_OWN',
                                           'COMMUNITY_WRITE_MESSAGE',
                                           'COMMUNITY_WRITE_OWN_MESSAGE',
                                           'COMMUNITY_READ_MESSAGE_ATTACHMENT',
                                           'COMMUNITY_WRITE_MESSAGE_ATTACHMENT',
                                           'COMMUNITY_WRITE_OWN_MESSAGE_ATTACHMENT',
                                           'IDEA_READ',
                                           'IDEA_WRITE',
                                           'IDEA_WRITE_OWN',
                                           'IDEA_APPROVAL',
                                           'IDEA_FAVORITE',
                                           'IDEA_READ_COMMENT',
                                           'IDEA_WRITE_COMMENT',
                                           'IDEA_WRITE_OWN_COMMENT',
                                           'IDEA_READ_ATTACHMENT',
                                           'IDEA_WRITE_ATTACHMENT',
                                           'IDEA_WRITE_OWN_ATTACHMENT',
                                           'KB_READ',
                                           'KB_WRITE_SECTION',
                                           'KB_WRITE_ARTICLE',
                                           'KB_READ_ATTACHMENT',
                                           'KB_WRITE_ATTACHMENT',
                                           'NOTE_READ',
                                           'NOTE_WRITE',
                                           'NOTIFICATION_READ',
                                           'NOTIFICATION_WRITE',
                                           'PERSON_READ',
                                           'PERSON_READ_SELF',
                                           'PERSON_READ_LOGIN',
                                           'PERSON_READ_LOGIN_SELF',
                                           'PERSON_CREATE',
                                           'PERSON_MODIFY',
                                           'PERSON_MODIFY_SELF',
                                           'PERSON_MODIFY_PERSONAL',
                                           'PERSON_MODIFY_PERSONAL_SELF',
                                           'PERSON_MODIFY_IMAGERY',
                                           'PERSON_MODIFY_IMAGERY_SELF',
                                           'PERSON_MODIFY_ROLE',
                                           'PERSON_MODIFY_PASSWORD',
                                           'PERSON_MODIFY_PASSWORD_SELF',
                                           'PERSON_BLOCK',
                                           'PERSON_WRITE_PROTECTION',
                                           'PERSON_YANDEX_CALENDAR',
                                           'REACTION_READ',
                                           'REACTION_WRITE',
                                           'ROLE_READ',
                                           'ROLE_WRITE',
                                           'SETTINGS_READ',
                                           'SETTINGS_WRITE',
                                           'STORY_READ',
                                           'STORY_WRITE',
                                           'STORY_WRITE_OWN',
                                           'TASK_READ',
                                           'TASK_READ_OWN',
                                           'TASK_WRITE',
                                           'TASK_WRITE_OWN',
                                           'TASK_APPROVAL',
                                           'TASK_READ_TAG',
                                           'TASK_WRITE_TAG',
                                           'TASK_READ_COMMENT',
                                           'TASK_WRITE_COMMENT',
                                           'TASK_WRITE_OWN_COMMENT',
                                           'TASK_READ_ATTACHMENT',
                                           'TASK_WRITE_ATTACHMENT',
                                           'TASK_WRITE_OWN_ATTACHMENT',
                                           'TITLE_READ',
                                           'TITLE_WRITE');

ALTER TABLE security_permission ADD COLUMN permission credential_permission UNIQUE NOT NULL;
