package ru.loylabs.portal.configuration.container;

import lombok.extern.slf4j.Slf4j;
import org.testcontainers.containers.JdbcDatabaseContainer;
import org.testcontainers.containers.PostgreSQLContainer;
import org.testcontainers.containers.output.Slf4jLogConsumer;

@Slf4j
public class PostgreSqlTestContainer implements SqlTestContainer {

	private PostgreSQLContainer<?> postgreSQLContainer;


	@Override
	public JdbcDatabaseContainer<?> getTestContainer() {
		return postgreSQLContainer;
	}

	@Override
	public void destroy() {
		if (null != postgreSQLContainer && postgreSQLContainer.isRunning()) {
			postgreSQLContainer.stop();
		}
	}

	@Override
	public void afterPropertiesSet()  {
		if (postgreSQLContainer == null) {
			postgreSQLContainer =
					new PostgreSQLContainer<>("postgres:13.3")
							.withDatabaseName("ltportal")
							.withLogConsumer(new Slf4jLogConsumer(log))
							.withReuse(true);
		}
		if (!postgreSQLContainer.isRunning()) {
			postgreSQLContainer.start();
		}
	}
}
