package ru.loylabs.portal.integration;

import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.transaction.annotation.Transactional;
import ru.loylabs.portal.Application;
import ru.loylabs.portal.configuration.annotation.EmbeddedSQL;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
@EmbeddedSQL
@SpringBootTest(classes = {Application.class})
@ActiveProfiles("test")
@Transactional
//@DirtiesContext(classMode = DirtiesContext.ClassMode.AFTER_CLASS)  -> The annotation is commented out because it may not be appropriate to use.
public @interface IntegrationTest {
}

