package ru.loylabs.portal.integration;

import org.junit.jupiter.api.AfterAll;
import org.springframework.beans.factory.annotation.Value;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.UUID;


@IntegrationTest
public abstract class IntegrationTestBase {

    protected static final UUID nonExistUUID = UUID.randomUUID();

    @AfterAll
    static void cleanup(@Value("${file.path}") String attachmentFilePath) throws IOException {
        Path folderPath = Path.of(attachmentFilePath);
        try (var filesWalk = Files.walk(folderPath)) {
            filesWalk.filter(Files::isRegularFile).forEach(file -> {
                try {
                    Files.delete(file);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            });
        }
    }

}
