//package ru.loylabs.portal.integration.controller;
//
//import org.junit.jupiter.api.DisplayName;
//import org.junit.jupiter.api.DynamicTest;
//import org.junit.jupiter.api.TestFactory;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.http.HttpStatus;
//import org.springframework.http.MediaType;
//import org.springframework.mock.web.MockMultipartFile;
//import org.springframework.test.web.servlet.MvcResult;
//import org.springframework.transaction.annotation.Transactional;
//import ru.loylabs.portal.integration.IntegrationTestBaseMVC;
//import ru.loylabs.portal.integration.util.JsonResponse;
//import ru.loylabs.portal.integration.util.data.MultipartFileGeneratorUtils;
//import ru.loylabs.portal.integration.util.data.StoryTestData;
//import ru.loylabs.portal.presentation.request.CreateStoryGroupRequest;
//import ru.loylabs.portal.presentation.request.CreateStoryRequest;
//import ru.loylabs.portal.presentation.request.UpdateStoryGroupRequest;
//import ru.loylabs.portal.repository.StoryGroupRepository;
//import ru.loylabs.portal.repository.StoryRepository;
//
//import java.util.UUID;
//import java.util.stream.Stream;
//
//import static org.junit.jupiter.api.DynamicTest.dynamicTest;
//import static org.springframework.http.HttpHeaders.AUTHORIZATION;
//import static org.springframework.http.HttpStatus.*;
//import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
//import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
//import static ru.loylabs.portal.config.URIConstants.*;
//import static ru.loylabs.portal.integration.util.JsonResponse.ID;
//import static ru.loylabs.portal.integration.util.MvcResultAssert.assertThat;
//import static ru.loylabs.portal.integration.util.TestUtils.convertToJsonString;
//import static ru.loylabs.portal.integration.util.data.StoryTestData.generateStoryGroup;
//
//@DisplayName("Story controller IT")
//@Transactional
//public class StoryControllerIT extends IntegrationTestBaseMVC {
//	public static final String STORY_GROUP_BASE_URI = VERSION_1_URI + STORY_GROUPS_URI;
//
//	public static final String STORY_BASE_URI = STORY_GROUP_BASE_URI + STORY_GROUP_ID_URI_PARAM + STORIES_URI;
//
//
//	@Autowired
//	private StoryGroupRepository storyGroupRepository;
//	@Autowired
//	private StoryRepository storyRepository;
//
//
//
//	@TestFactory
//	Stream<DynamicTest> findAllStoryGroupTest() {
//		final String methodName = "Find all story group. ";
//		storyGroupRepository.save(generateStoryGroup(admin));
//		var size = storyGroupRepository.findAll().size();
//		return Stream.of(
//				dynamicTest(methodName + "By admin",
//						() -> findAllPerform(admin.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().totalItems(size).build())),
//				dynamicTest(methodName + "By editor",
//						() -> findAllPerform(editor.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().totalItems(size).build())),
//				dynamicTest(methodName + "By user",
//						() -> findAllPerform(user.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().totalItems(size).build())));
//	}
//
//	private void findAllPerform(UUID requestFrom, HttpStatus status, JsonResponse expectedBody) throws Exception {
//		MvcResult result = mockMvc.perform(get(STORY_GROUP_BASE_URI)
//						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom)))
//				.andReturn();
//		assertThat(result).hasStatus(status).hasBody(expectedBody);
//	}
//
//	@TestFactory
//	Stream<DynamicTest> findOneStoryGroupTest() throws Exception {
//		final String methodName = "Find story group by id. ";
//		var storyGroup = storyGroupRepository.save(StoryTestData.generateEmptyStoryGroup(admin));
//		return Stream.of(
//				dynamicTest(methodName + "By admin",
//						() -> findOneStoryGroupPerform(admin.getId(), storyGroup.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().id(storyGroup.getId()).build())),
//				dynamicTest(methodName + "By editor",
//						() -> findOneStoryGroupPerform(editor.getId(), storyGroup.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().id(storyGroup.getId()).build())),
//				dynamicTest(methodName + "By user",
//						() -> findOneStoryGroupPerform(user.getId(), storyGroup.getId(), OK,
//								JsonResponse.expectedFieldsBuilder().id(storyGroup.getId()).build())),
//				dynamicTest(methodName + "By admin. Non existing group",
//						() -> findOneStoryGroupPerform(admin.getId(), nonExistUUID, BAD_REQUEST,
//								JsonResponse.expectedFieldsBuilder().errorMessage(nonExistUUID.toString()).build())));
//	}
//
//	private void findOneStoryGroupPerform(UUID requestFrom, UUID storyGroupId, HttpStatus status, JsonResponse expectedBody) throws Exception {
//		MvcResult result = mockMvc.perform(get(STORY_GROUP_BASE_URI + STORY_GROUP_ID_URI_PARAM, storyGroupId)
//						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom)))
//				.andReturn();
//
//		assertThat(result).hasStatus(status).hasBody(expectedBody);
//	}
//
//	@TestFactory
//	Stream<DynamicTest> createStoryGroupTest() throws Exception {
//		final String methodName = "Create story group. ";
//		var request = StoryTestData.generateCreateStoryGroupRequest();
//		request.setRequests(new CreateStoryRequest[]{StoryTestData.generateCreateStoryRequest(), StoryTestData.generateCreateStoryRequest()});
//		var file = MultipartFileGeneratorUtils.generateFile("files", MediaType.IMAGE_JPEG);
//		var filesWrongType = MultipartFileGeneratorUtils.generateFile("files", MediaType.APPLICATION_JSON);
//
//		return Stream.of(
//				dynamicTest(methodName + "By user",
//						() -> createStoryGroupPerform(user.getId(), request, file, file, FORBIDDEN, null)),
//				dynamicTest(methodName + "By editor",
//						() -> createStoryGroupPerform(editor.getId(), request, file, file, OK,
//								JsonResponse.expectedFieldsBuilder().notEmptyField(ID).build())),
//				dynamicTest(methodName + "By admin",
//						() -> createStoryGroupPerform(admin.getId(), request, file, file, OK,
//								JsonResponse.expectedFieldsBuilder().notEmptyField(ID).build())),
//				dynamicTest(methodName + "By admin. Wrong file",
//						() -> createStoryGroupPerform(admin.getId(), request, file, filesWrongType, BAD_REQUEST,
//								JsonResponse.expectedFieldsBuilder().errorMessage("images").build())),
//				dynamicTest(methodName + "By admin. Wrong amount",
//						() -> createStoryGroupPerform(admin.getId(), request, file, null, BAD_REQUEST,
//								JsonResponse.expectedFieldsBuilder().errorMessage("amount").build()))
//		);
//	}
//
//	void createStoryGroupPerform(UUID requestFrom, CreateStoryGroupRequest request, MockMultipartFile file1, MockMultipartFile file2, HttpStatus status, JsonResponse expectedBody) throws Exception {
//		var part = new MockMultipartFile("request", "", APPLICATION_JSON_VALUE, convertToJsonString(request).getBytes());
//		MvcResult result = file2 != null ?
//				mockMvc.perform(multipart(STORY_GROUP_BASE_URI)
//								.file(file1)
//								.file(file2)
//								.file(part)
//								.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom))
//								.contentType(MediaType.MULTIPART_FORM_DATA))
//						.andReturn()
//				:
//				mockMvc.perform(multipart(STORY_GROUP_BASE_URI)
//								.file(file1)
//								.file(part)
//								.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom))
//								.contentType(MediaType.MULTIPART_FORM_DATA))
//						.andReturn();
//
//		assertThat(result).hasStatus(status).hasBody(expectedBody);
//	}
//
//	@TestFactory
//	Stream<DynamicTest> updateStoryGroupTest() {
//		final String methodName = "Update story group. ";
//		var group = storyGroupRepository.save(generateStoryGroup(admin));
//		var groupFromEditor = storyGroupRepository.save(generateStoryGroup(user));
//		var request = StoryTestData.generateUpdateStoryGroupRequest();
//		return Stream.of(
//				dynamicTest(methodName + "By user",
//						() -> updateStoryGroupPerform(user.getId(), group.getId(), request, FORBIDDEN, null)),
//				dynamicTest(methodName + "By admin",
//						() -> updateStoryGroupPerform(admin.getId(), group.getId(), request, OK,
//								JsonResponse.expectedFieldsBuilder().expected("pinned", request.getPinned()).build())),
//				dynamicTest(methodName + "By editor. Group from admin",
//						() -> updateStoryGroupPerform(editor.getId(), group.getId(), request, OK,
//								JsonResponse.expectedFieldsBuilder().expected("pinned", request.getPinned()).build())),
//				dynamicTest(methodName + "By admin. Group from editor",
//						() -> updateStoryGroupPerform(editor.getId(), groupFromEditor.getId(), request, OK,
//								JsonResponse.expectedFieldsBuilder().expected("pinned", request.getPinned()).build())),
//				dynamicTest(methodName + "By editor",
//						() -> updateStoryGroupPerform(admin.getId(), nonExistUUID, request, BAD_REQUEST,
//								JsonResponse.expectedFieldsBuilder().errorMessage(nonExistUUID.toString()).build()))
//		);
//	}
//
//	void updateStoryGroupPerform(UUID requestFrom, UUID storyGroupId, UpdateStoryGroupRequest request, HttpStatus status, JsonResponse expectedBody) throws Exception {
//		MvcResult result = mockMvc.perform(put(STORY_GROUP_BASE_URI + STORY_GROUP_ID_URI_PARAM, storyGroupId)
//						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom))
//						.content(convertToJsonString(request))
//						.contentType(MediaType.APPLICATION_JSON))
//				.andReturn();
//
//		assertThat(result).hasStatus(status).hasBody(expectedBody);
//	}
//
////	@ParameterizedTest(name = "Delete story group by id." + ARGUMENT_INDEX)
////	@MethodSource("deleteStoryGroupArguments")
////	void deleteStoryGroupTest(UUID requestFrom, UUID storyGroupId, HttpStatus status) throws Exception {
////		MvcResult result = mockMvc.perform(delete(STORY_GROUP_BASE_URI + STORY_GROUP_ID_URI_PARAM, storyGroupId)
////						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom)))
////				.andReturn();
////
////		assertThat(result).hasStatus(status);
////	}
////
////	public Stream<Arguments> deleteStoryGroupArguments() {
////		var group = storyGroupRepository.save(generateStoryGroup(admin));
////		var groupByEditor = storyGroupRepository.save(generateStoryGroup(editor));
////		return Stream.of(
////				arguments(user.getId(), group.getId(), FORBIDDEN),
////				arguments(admin.getId(), group.getId(), OK),
////				arguments(admin.getId(), groupByEditor.getId(), OK),
////				arguments(editor.getId(), groupByEditor.getId(), OK),
////				arguments(editor.getId(), group.getId(), OK),
////				arguments(admin.getId(), nonExistUUID, BAD_REQUEST)
////		);
////	}
//////
////	@ParameterizedTest(name = "Find all story in group." + ARGUMENT_INDEX)
////	@MethodSource("findAllStoryArguments")
////	void findAllStoryTest(UUID requestFrom,UUID storyGroupId, HttpStatus status, JsonResponse expectedBody) throws Exception {
////		MvcResult result = mockMvc.perform(get(STORY_BASE_URI,storyGroupId)
////						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom)))
////				.andReturn();
////		assertThat(result).hasStatus(status).hasBody(expectedBody);
////	}
////
////	public Stream<Arguments> findAllStoryArguments() {
////		var group = storyGroupRepository.save(generateStoryGroup(admin));
////		var size = storyRepository.findAllByGroupId(group.getId()).size();
////		return Stream.of(
////				arguments(admin.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////				arguments(editor.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////				arguments(user.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////				arguments(admin.getId(),nonExistUUID, BAD_REQUEST, JsonResponse.expectedFieldsBuilder().errorMessage(nonExistUUID.toString()).build())
////		);
////	}
////
////	@ParameterizedTest(name = "Find one story in group by id." + ARGUMENT_INDEX)
////	@MethodSource("findOneStoryArguments")
////	@Transactional
////	void findOneStoryTest(UUID requestFrom,UUID storyGroupId, HttpStatus status, JsonResponse expectedBody) throws Exception {
////		MvcResult result = mockMvc.perform(get(STORY_BASE_URI,storyGroupId)
////						.header(AUTHORIZATION, tokenProvider.getPersonalTokenById(requestFrom)))
////				.andReturn();
////		assertThat(result).hasStatus(status).hasBody(expectedBody);
////	}
////
////
////
////	public Stream<Arguments> findOneStoryArguments() {
////			var group = storyGroupRepository.save(generateStoryGroup(admin));
////			var size = storyRepository.findAll().size();
////			return Stream.of(
////					arguments(admin.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////					arguments(editor.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////					arguments(user.getId(),group.getId(), OK, JsonResponse.expectedFieldsBuilder().totalItems(size).build()),
////					arguments(admin.getId(),nonExistUUID, BAD_REQUEST, JsonResponse.expectedFieldsBuilder().errorMessage(nonExistUUID.toString()).build())
////			);
////		}
//
//}
