package ru.loylabs.portal.integration.util;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import org.springframework.data.jpa.repository.JpaRepository;

import java.text.SimpleDateFormat;

public class TestUtils {

	private static final ObjectMapper mapper = createObjectMapper();

	private static ObjectMapper createObjectMapper() {
		ObjectMapper mapper = new ObjectMapper();
		mapper.configure(SerializationFeature.WRITE_DURATIONS_AS_TIMESTAMPS, false);
		mapper.setSerializationInclusion(JsonInclude.Include.NON_EMPTY);
		mapper.registerModule(new JavaTimeModule());
		mapper.setDateFormat(new SimpleDateFormat("yyyy-MM-dd"));
		return mapper;
	}

	public static String convertToJsonString(Object object) throws JsonProcessingException {
		return mapper.writeValueAsString(object);
	}

	public static <ID,T> T  randomFromBD(JpaRepository<T,ID> repository){
		return repository.findAll().stream().findAny().orElseThrow();
	}

}
