package ru.loylabs.portal.integration.util.data;

import org.instancio.Instancio;
import ru.loylabs.portal.entity.Community;
import ru.loylabs.portal.entity.CommunityPersonRole;
import ru.loylabs.portal.enums.CommunityRole;
import ru.loylabs.portal.presentation.request.*;
import ru.loylabs.portal.presentation.view.CommunityListView;
import ru.loylabs.portal.presentation.view.CommunityRecordView;
import ru.loylabs.portal.presentation.view.CommunityView;
import ru.loylabs.portal.presentation.view.PersonCommunityView;

import java.time.Instant;
import java.util.UUID;

import static org.instancio.Select.field;

public class CommunityTestData {
    public static Community generateCommunity(UUID id) {
        return Instancio.of(Community.class)
                .set(field(Community::getId), id)
                .set(field(Community::getCreatedAt), Instant.now())
                .create();

    }

    public static CreateCommunityRequest generateCreateCommunityRequest(boolean privateCommunity) {
        return Instancio.of(CreateCommunityRequest.class)
                .set(field(CreateCommunityRequest::getPrivateCommunity), privateCommunity)
                .create();
    }

    public static CreateCommunityRequest generateCreateCommunityRequest() {
        return Instancio.of(CreateCommunityRequest.class)
                .create();
    }

    public static CommunityView generateCommunityView(UUID id) {
        return Instancio.of(CommunityView.class)
                .set(field(CommunityView::getId), id.toString())
                .create();
    }

    public static CommunityView generateCommunityView() {
        return Instancio.of(CommunityView.class)
                .set(field(CommunityView::getId), UUID.randomUUID().toString())
                .create();
    }

    public static UpdateCommunityRequest generateUpdateCommunityRequest() {
        return Instancio.of(UpdateCommunityRequest.class)
                .create();
    }

    public static CommunityRole createCommunityRole() {
        return Instancio.of(CommunityRole.class)
                .create();
    }

    public static AddMembersRequest createAddMemberRequest(UUID id) {
        return Instancio.of(AddMembersRequest.class)
                .create();
    }

    public static UpdateRoleInCommunityRequest createUpdateRoleInCommunityRequest() {
        return Instancio.of(UpdateRoleInCommunityRequest.class)
                .create();
    }

    public static DeleteMemberRequest generateDeleteMemberRequest() {
        return Instancio.of(DeleteMemberRequest.class)
                .create();
    }

    public static CommunityListView generateCommunityListView(UUID id) {
        return Instancio.of(CommunityListView.class)
                .set(field(CommunityListView::getId), id.toString())
                .create();
    }

    public static CommunityPersonRole generateCommunityPersonRole() {
        return Instancio.of(CommunityPersonRole.class)
                .create();
    }

    public static CommunityPersonRole generateCommunityPersonRole(Community community) {
        return Instancio.of(CommunityPersonRole.class)
                .set(field(CommunityPersonRole::getCommunity), community)
                .create();
    }

    public static CommunityRole generateCommunityRole(UUID id) {
        return Instancio.of(CommunityRole.class)
                .set(field(CommunityListView::getId), id.toString())
                .create();
    }

    public static PersonCommunityView generatePersonCommunityView(UUID id) {
        return Instancio.of(PersonCommunityView.class)
                .set(field(PersonCommunityView::getId), id.toString())
                .create();
    }

    public static CommunityRecordView generateCommunityRecordView(UUID idRecord) {
        return Instancio.of(CommunityRecordView.class)
                .set(field(CommunityRecordView::getId), idRecord.toString())
                .create();
    }
}