package ru.loylabs.portal.integration.util.data;

import org.springframework.http.MediaType;
import org.springframework.mock.web.MockMultipartFile;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;

public class MultipartFileGeneratorUtils {

	public static MockMultipartFile generateFile(String name,MediaType type) throws IOException {
		byte[] image = Files.readAllBytes(new File("src/test/resources/files/test_duck.jpg").toPath());
		byte[] json = Files.readAllBytes(new File("src/test/resources/files/test_json.json").toPath());
		if(type == MediaType.IMAGE_JPEG) {
			return new MockMultipartFile(name, "test_duck.jpg", MediaType.IMAGE_JPEG_VALUE, image);
		} else if (type == MediaType.APPLICATION_JSON)
			return new MockMultipartFile(name, "test_json.json", MediaType.APPLICATION_JSON_VALUE, json);
		else return new MockMultipartFile(name, "test_duck.html", MediaType.APPLICATION_JSON_VALUE, image);
	}
	public static MockMultipartFile generateFile(MediaType type) throws IOException {
		byte[] image = Files.readAllBytes(new File("src/test/resources/files/test_duck.jpg").toPath());
		if(type == MediaType.IMAGE_JPEG) {
			return new MockMultipartFile("file", "test_duck.jpg", MediaType.IMAGE_JPEG_VALUE, image);
		} else if (type == MediaType.APPLICATION_JSON) return new MockMultipartFile("file", "test_duck.html", MediaType.APPLICATION_JSON_VALUE, image);
		else return new MockMultipartFile("file", "test_duck.txt", MediaType.APPLICATION_JSON_VALUE, image);
	}

}
