package ru.loylabs.portal.integration.util.data;

import org.instancio.Instancio;
import ru.loylabs.portal.entity.Contact;
import ru.loylabs.portal.entity.Person;
import ru.loylabs.portal.entity.Record;
import ru.loylabs.portal.presentation.request.CreateRecordRequest;
import ru.loylabs.portal.presentation.request.DeleteAttachmentsRequest;
import ru.loylabs.portal.presentation.request.UpdateRecordRequest;
import ru.loylabs.portal.presentation.view.CommentView;

import java.util.UUID;

import static org.instancio.Select.field;

public class RecordTestData {
    public static Record generateRecord() {
        return Instancio.of(Record.class)
                .create();
    }

    public static Record generateRecord(UUID id) {
        return Instancio.of(Record.class)
                .set(field(Record::getId),id)
                .create();
    }

    public static CreateRecordRequest generateCreateRecordRequest() {
        return Instancio.of(CreateRecordRequest.class)
                .create();
    }

    public static UpdateRecordRequest generateUpdateRecordRequest() {
        return Instancio.of(UpdateRecordRequest.class)
                .create();
    }

    public static CommentView generateCommentView() {
        return Instancio.of(CommentView.class)
                .create();
    }

    public static CommentView generateCommentView(UUID id) {
        return Instancio.of(CommentView.class)
                .set(field(CommentView::getId),id.toString())
                .create();
    }

    public static DeleteAttachmentsRequest generateDeleteAttachmentsRequest() {
        return Instancio.of(DeleteAttachmentsRequest.class)
                .create();
    }
}
