package ru.loylabs.portal.unit.controller;

import org.junit.jupiter.api.BeforeAll;
import org.mockito.MockedStatic;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.WebMvcTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.context.annotation.Import;
import org.springframework.test.web.servlet.MockMvc;
import ru.loylabs.portal.config.ServiceConfig;
import ru.loylabs.portal.config.WebSecurityConfig;
import ru.loylabs.portal.config.jwt.JwtFilter;
import ru.loylabs.portal.config.jwt.JwtProvider;
import ru.loylabs.portal.config.jwt.JwtUtils;
import ru.loylabs.portal.presentation.SecurityUtil;
import ru.loylabs.portal.repository.PersonRepository;
import ru.loylabs.portal.service.security.Credential;
import ru.loylabs.portal.utility.PathUtil;
import ru.loylabs.portal.utility.StaticMessageSource;

import java.util.Objects;

import static org.mockito.Mockito.mockStatic;
import static ru.loylabs.portal.integration.util.data.PersonTestData.generatePerson;


@WebMvcTest
@Import({WebSecurityConfig.class,
        PathUtil.class,
        JwtFilter.class,
        JwtProvider.class,
        JwtUtils.class,
        StaticMessageSource.class,
        ServiceConfig.class})
public class BaseControllerTest{

    @Autowired
    protected MockMvc mockMvc;

    @MockBean
    private PersonRepository personRepository;

    private static MockedStatic<SecurityUtil> utiles;

    @BeforeAll
    public static void setup() {
        if (Objects.isNull(utiles)) {
            var userCredential = new Credential(generatePerson());
            utiles = mockStatic(SecurityUtil.class);
            utiles.when(SecurityUtil::getCredential).thenReturn(userCredential);
        }
    }
}
