import React, { FC } from "react";

import { Box, Typography } from "@mui/material";

interface NameListProps {
  title: string;
  names: string[];
}

export const NameList: FC<NameListProps> = ({ title, names }) => {
  return (
    <Box>
      <Typography color={(theme) => theme.palette.text.secondary}>
        {title}
      </Typography>
      {names.map((item, index) => (
        <Typography key={index}>{item}</Typography>
      ))}
    </Box>
  );
};

export default NameList;
