import React, { FC, useContext } from "react";

import Typography from "@mui/material/Typography";
import { Box, Paper } from "@mui/material";

import UserAvatar from "../../../common/User/UserAvatar/UserAvatar";
import { joyUser } from "../../../layout/RightSidebar/Members/joyUser";
import { AppContext } from "../../../shared/AppContextProvider";
import JoyHelpButton from "../../../common/Buttons/JoyHelpButton/JoyHelpButton";

export const JoyHelpSection: FC = () => {
  const { isMobile } = useContext(AppContext);

  const stylePaper = {
    mt: 7,
    p: 4,
    borderRadius: "12px",
    display: "flex",
    justifyContent: "space-between",
    flexDirection: isMobile ? "column-reverse" : "row",
  };

  const styleAvatar = {
    width: "64px",
    height: "64px",
  };

  return (
    <Paper sx={stylePaper}>
      <Box>
        <Typography variant="h4" mb="28px">
          Есть вопросы? Я помогу!
        </Typography>
        <JoyHelpButton color="primary" disabled />
      </Box>
      <Box mb={isMobile ? 3 : undefined}>
        <UserAvatar userInfo={joyUser} styles={styleAvatar} />
      </Box>
    </Paper>
  );
};

export default JoyHelpSection;
