import React, {useContext} from 'react';
import DialogWrapper from "../../common/Modals/DialogWrapper/DialogWrapper";
import CustomButton from "../../common/Buttons/CustomButton/CustomButton";
import Typography from "@mui/material/Typography";
import {ReviewContext} from "../RewievContextProvider/ReviewContextProvider";

const styleButton = {
    borderRadius: "60px",
    padding: "12px 24px",
    height: "auto",
};

const styleDialogWrapper = {display: "flex", justifyContent: "center", alignItems: "center"}
const styleDialogContentPaddingBottom = {pb:'5px'}

const ApprovedModal = () => {
    const {openApprovedModal, handleApprovedModal} = useContext(ReviewContext)

    return (
        <DialogWrapper
            openModal={openApprovedModal}
            handleModal={handleApprovedModal}
            width="532px"
            stylesContent={{...styleDialogWrapper, ...styleDialogContentPaddingBottom}}
            pActions={'24px'}
            styleActionButtons={styleDialogWrapper}
            buttons={
                <CustomButton
                    color="primary"
                    onClick={handleApprovedModal}
                    styles={styleButton}
                    text={'Хорошо'}
                />
            }>
            <Typography variant={'subtitle1'}>Спасибо, ваш голос засчитан</Typography>
        </DialogWrapper>
    );
};

export default ApprovedModal;