import React, { FC } from "react";

import Box from "@mui/material/Box";
import Typography from "@mui/material/Typography";

import { theme } from "../../../constants/theme";
import { ReactComponent as TrashIcon } from "../../../assets/icons/trash.svg";
import { AchievementView } from "../../../models/achievement.models";

interface ActiveGoalsProps {
  withDelete?: boolean;
  handleDelete?: (event: React.MouseEvent<HTMLDivElement>) => void;
  goalData: AchievementView;
  genericName?: boolean;
}

export const StepTitle: FC<ActiveGoalsProps> = ({
  withDelete,
  handleDelete,
  goalData,
  genericName,
}) => {
  return (
    <Box display="flex" justifyContent="space-between" mb={2}>
      <Typography variant="subtitle1">
        {genericName ? "Чек-лист" : goalData?.name}
      </Typography>
      <Box display="flex" gap={3} alignItems="center">
        <Typography variant="body1" color={theme?.palette?.text?.secondary}>
          {goalData?.countOfDoneTasks} из {goalData?.tasksSize}
        </Typography>
        {/*{withDelete && (*/}
        {/*  <TrashIcon onClick={handleDelete} style={{ cursor: "pointer" }} />*/}
        {/*)}*/}
      </Box>
    </Box>
  );
};

export default StepTitle;
