import { PersonView } from "./profile.models";
import { CommentView } from "./comment.models";
import { AttachmentView } from "./attachment.model";

export type TaskView = {
  attachments: AttachmentView[];
  author: PersonView;
  commentSize: number;
  content: string;
  date: string;
  header: string;
  id: string;
  modified: boolean;
  modifyAt: string;
  modifyBy: PersonView;
  observers: PersonView[];
  reaction: { id: string };
  sequence: number;
  status: string;
  tags: TaskTagView[];
  topComments: CommentView[];
};

export type AchievementView = {
  author: PersonView;
  countOfDoneTasks: number;
  creationDate: string;
  id: string;
  name: string;
  observers: PersonView[];
  status: string;
  tasksSize: number;
};

export type TaskTagView = {
  color: string;
  id: string;
  name: string;
};

// Types for API requests
export type CreateAchievementRequest = {
  name: string;
  observerIds: string[];
  ownerId: string;
};

export type CreateTaskTagRequest = {
  color: string;
  name: string;
};

export type UpdateTaskRequest = {
  content: string | null;
  header: string | null;
  observerIds: string[] | null;
};

export type UpdateTaskStatus = {
  sequence: number | null;
  status: string | null;
};
