import { JobView, PersonView } from "./profile.models";
import { AttachmentView } from "./attachment.model";

export type MemberRole = "ADMIN" | "MEMBER" | "OWNER";

export type SecurityRoleView = { role: string };

export type PersonCommunityView = {
  avatar: AttachmentView | null;
  background: AttachmentView | null;
  blocked: boolean;
  communityRole: string;
  id: string;
  job: JobView;
  name: string;
  patronymic: string;
  role: SecurityRoleView;
  surname: string;
};

export type CommunityRecordView = {
  attachments?: AttachmentView[];
  author: PersonView;
  content: string;
  date: string;
  id: string;
  reaction?: any;
};

export type CommunityListView = {
  avatar: AttachmentView | null;
  createdAt: string;
  description: string;
  id: string;
  membersCount: number;
  name: string;
  privateCommunity: boolean;
};

export type CommunityView = {
  avatar: AttachmentView | null;
  createdAt: string;
  description: string;
  id: string;
  name: string;
  privateCommunity: boolean;
  role: string;
};
