import {AchievementView} from "./achievement.models";
import {AttachmentView} from "./attachment.model";

export type TitleView = {
    id: string;
    name: string;
};
export type DepartmentView = {
    id: string;
    name: string;
};
export type CityView = {
    id: string;
    name: string;
};

export type JobView = {
    department: DepartmentView;
    grade: string;
    id: string;
    title: TitleView;
};

export type ContactView = {
    email: string;
    github: string;
    id: string;
    instagram: string;
    linkedin: string;
    phone: string;
    skype: string;
    telegram: string;
    vk: string;
};

export type SecurityRoleView = { role: string };

export type PersonView = {
    achievements?: AchievementView[];
    avatar?: AttachmentView | null;
    background?: AttachmentView | null;
    blocked: boolean;
    city: CityView;
    contact: ContactView;
    description: string;
    dob: string;
    fired: string | null;
    gender: string;
    hired: string;
    id: string;
    job: JobView;
    name: string;
    patronymic: string;
    role: SecurityRoleView;
    surname: string;
};

export type SelectedPerson = PersonView & {
    isChecked: boolean
}