import { PersonView } from './profile.models'

export type CreateReviewRequest = {
  ownerId: string
  reviewersId: string[]
  skillId: string
}

export type EditReviewRequest = {
  reviewersId: string[]
  endReview: string
}

export type Skill = {
  id: string
  name: string
}

export type ReviewList = {
  id: string
  owner: PersonView
  reviewers: Reviewers[]
  skill: Skill
  endReview?: string
  startReview?: string
}

export interface Reviewers {
  reviewer: PersonView
  voted: boolean
}

export interface ReviewRating {
  id: string
  rating: number
  review: ReviewList
}

export interface Estimations {
  [key: string]: {
    items: ReviewRating[]
    totalItems: number
  }
}

export type EditReviewParams = {
  reviewId: string
  body: {
    reviewersId: string[]
    endReview: string
  }
}

export type VotedReviewers = {
  id: string
  isVoted: boolean
}
