import { achievementsInitial } from "../actions/achievements";
import { ACHIEVEMENTS } from "../constants/actions";
import {
  AchievementView,
  TaskTagView,
  TaskView,
} from "../models/achievement.models";
import { CommentView } from "../models/comment.models";
import { ReturnActionsTypes } from "../store";
import { initialAchievements } from "./initialStates/initialAchievements";

type AchievementsInfo = {
  achievement: AchievementView;
  achievementTask: TaskView;
  achievementsList: AchievementView[];
  achievementTags: TaskTagView[];
  achievementComments: CommentView[];
};

const initialState: AchievementsInfo = initialAchievements;

export type achievementsType = ReturnActionsTypes<typeof achievementsInitial>;

export const achievementsReducer = (
  state = initialState,
  action: achievementsType
) => {
  switch (action.type) {
    case ACHIEVEMENTS.ACHIEVEMENT:
      return { ...state, achievement: action.payload };
    case ACHIEVEMENTS.ACHIEVEMENT_TASK:
      return { ...state, achievementTask: action.payload };
    case ACHIEVEMENTS.ACHIEVEMENTS_LIST:
      return { ...state, achievementsList: action.payload };
    case ACHIEVEMENTS.ACHIEVEMENT_TAGS:
      return { ...state, achievementTags: action.payload };
    case ACHIEVEMENTS.ACHIEVEMENT_COMMENTS:
      return { ...state, achievementComments: action.payload };
    default:
      return state;
  }
};
