import { calendarInitial } from "../actions/calendar";
import { CALENDAR } from "../constants/actions";
import { ReturnActionsTypes } from "../store";
import { initialCalendar } from "./initialStates/initialCalendar";

type CalendarInfo = {
  allEvents: any;
  eventsFilter: string[];
};

const initialState: CalendarInfo = initialCalendar;

export type calendarType = ReturnActionsTypes<typeof calendarInitial>;

export const calendarReducer = (state = initialState, action: calendarType) => {
  switch (action.type) {
    case CALENDAR.ALL_EVENTS:
      return { ...state, allEvents: action.payload };
    case CALENDAR.FILTER_EVENTS:
      return { ...state, eventsFilter: action.payload };
    default:
      return state;
  }
};